unit AccountsTree;

{$mode objfpc}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ComCtrls, Menus, Buttons;

type

  { TfmAccountsTree }

  TfmAccountsTree = class(TForm)
    bbSelect: TBitBtn;
    bbRefresh: TBitBtn;
    BitBtn3: TBitBtn;
    ImageList1: TImageList;
    MenuItem1: TMenuItem;
    PopupMenu1: TPopupMenu;
    TreeView1: TTreeView;
    procedure bbSelectClick(Sender: TObject);
    procedure bbRefreshClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
  private
    { private declarations }
  public
    SelectedAccountID: Integer;
    fRootAccountID: Integer;
    procedure Init(RootAccountID: Integer = -1; ShowButtons: Boolean = True; ExpandNodes: Boolean = False);
    { public declarations }
  end; 

var
  fmAccountsTree: TfmAccountsTree;

implementation

{ TfmAccountsTree }

uses AddAccount, Data;

procedure TfmAccountsTree.MenuItem1Click(Sender: TObject);
var
  AccountID: Integer;
begin
  fmAddAccount.Show;
  if TreeView1.Selected <> nil then
    AccountID:= TreeView1.Selected.OverlayIndex
  else
    AccountID:= -1;
  fmAddAccount.Init(AccountID);
end;

procedure TfmAccountsTree.TreeView1DblClick(Sender: TObject);
begin
  if TreeView1.Selected <> nil then
      bbSelectClick(nil);
end;

procedure TfmAccountsTree.Init(RootAccountID: Integer = -1; ShowButtons: Boolean = True; ExpandNodes: Boolean = False);
begin
  fRootAccountID:= RootAccountID;
  bbSelect.Visible:= ShowButtons;
  dmData.FillAccountsTree(TreeView1, RootAccountID, ExpandNodes);
end;

procedure TfmAccountsTree.bbSelectClick(Sender: TObject);
begin
  if TreeView1.Selected <> nil then
    begin
      SelectedAccountID:= TreeView1.Selected.OverlayIndex;
      ModalResult:= mrOK;
    end;
end;

procedure TfmAccountsTree.bbRefreshClick(Sender: TObject);
begin
  Init(fRootAccountID, bbSelect.Visible, TreeView1.AutoExpand);
end;

procedure TfmAccountsTree.FormActivate(Sender: TObject);
begin
end;

initialization
  {$I accountstree.lrs}

end.

