unit AddAccount;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons, DbCtrls, sqldb, db, Data;

type

  { TfmAddAccount }

  TfmAddAccount = class(TForm)
    bbAdd: TBitBtn;
    cbParentAccount: TComboBox;
    cxBranch: TCheckBox;
    edDetails: TEdit;
    edAccountName: TEdit;
    Label1: TLabel;
    Label5: TLabel;
    procedure bbAddClick(Sender: TObject);
    procedure cxBranchClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
  private
    AccountIDs: TAccountIDs;
    { private declarations }
  public
    procedure Init(AccountID: Integer);
    { public declarations }
  end; 

var
  fmAddAccount: TfmAddAccount;

implementation

{ TfmAddAccount }

procedure TfmAddAccount.bbAddClick(Sender: TObject);
var
  ParentAccountID: Integer;
begin
  if (Trim(edAccountName.Text) <> '') and (Trim(edDetails.Text) <> '') and
    ((not cxBranch.Checked) or (cbParentAccount.ItemIndex <> -1)) then
  begin
    if cxBranch.Checked then
      ParentAccountID:= AccountIDs[cbParentAccount.ItemIndex]
    else
      ParentAccountID:= 0;

    if dmData.AddNewAccount(edAccountName.Text, edDetails.Text, ParentAccountID) then
    begin
      ShowMessage('تمت إضافة الحساب الجديد بنجاح');
      Close;
    end;
  end
  else
    ShowMessage('يجب إدخال كل الحقول');
end;

procedure TfmAddAccount.cxBranchClick(Sender: TObject);
begin
  cbParentAccount.Visible:= cxBranch.Checked;
end;


procedure TfmAddAccount.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  cxBranch.Checked:= False;
end;

procedure TfmAddAccount.Init(AccountID: Integer);
var
  i: Integer;
begin
  cxBranch.Checked:= AccountID <> -1;
  cbParentAccount.Visible:= cxBranch.Checked;
  edAccountName.Clear;
  dmData.FillAccountsBox(cbParentAccount.Items, AccountIDs, '');
  edDetails.Clear;
  if AccountID <> -1 then
  begin
      for i:= 0 to High(AccountIDs) do
        if AccountIDs[i] = AccountID then
        begin
          cbParentAccount.ItemIndex:= i;
          Break;
        end;
  end;
end;

initialization
  {$I addaccount.lrs}

end.

