unit AddTrans;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, FileUtil, LResources, Forms, Controls, Graphics,
  Dialogs, StdCtrls, DbCtrls, Buttons;

type

  { TfmAddTrans }

  TfmAddTrans = class(TForm)
    bbOk: TBitBtn;
    bbSelDebitAcc: TBitBtn;
    bbSelCreditAcc: TBitBtn;
    cbDebitAccount: TComboBox;
    cbCreditAccount: TComboBox;
    edValue: TEdit;
    edDetails: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    laCurrency: TLabel;
    procedure bbOkClick(Sender: TObject);
    procedure bbSelDebitAccClick(Sender: TObject);
    procedure edValueKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { private declarations }
    AccountIDs: array of Integer;
    function Validate: Boolean;
  public
    { public declarations }
    procedure Init(Currency: string);
  end; 

var
  fmAddTrans: TfmAddTrans;

implementation

uses Data, AccountsTree, NumbersLib;

{ TfmAddTrans }

procedure TfmAddTrans.bbOkClick(Sender: TObject);
var
  EntryID: Integer;
begin
  if Validate then
  begin
    EntryID:= dmData.GetEntryID;
    if EntryID <> -1 then
    begin
      if dmData.InsertTrans(AccountIDs[cbDebitAccount.ItemIndex], EntryID, 1, 0,  StrToFloat(Trim(edValue.Text)), edDetails.Text) and
        dmData.InsertTrans(AccountIDs[cbCreditAccount.ItemIndex], EntryID, 1, StrToFloat(Trim(edValue.Text)), 0, edDetails.Text) then
        begin
          dmData.SQLTransaction1.Commit;
          ShowMessage('تمت إضافة القيد المزدوج بنجاح');
          ModalResult:= mrOK;
        end;

    end;
  end;
end;

procedure TfmAddTrans.bbSelDebitAccClick(Sender: TObject);
var
  i: Integer;
begin
  fmAccountsTree.Init;
  if fmAccountsTree.ShowModal = mrOK then
  begin
    for i:= 0 to High(AccountIDs) do
      if fmAccountsTree.SelectedAccountID = AccountIDs[i] then
      begin
        if (Sender as TControl).Tag = 0 then
          cbDebitAccount.ItemIndex:= i
        else
          cbCreditAccount.ItemIndex:= i;
        Break;
      end;
  end;
end;

procedure TfmAddTrans.edValueKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Sum: Double;
begin
  if Key = 13 then
  begin
    if GetOperandsCount(edValue.Text) = 0 then
    begin
      if Validate then
        if MessageDlg('إدراج  هذه المعاملة', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
          bbOkClick(nil);
    end
    else
    begin
      Sum:= NumbersLib.SimpleCalculate(edValue.Text);
      edValue.Text:= FloatToStr(Sum);;
    end;
  end;
end;


function TfmAddTrans.Validate: Boolean;
begin
  Result:= False;
  if Trim(edValue.Text) = '' then
    ShowMessage('يجب إدخال المبلغ')
  else
  if cbDebitAccount.ItemIndex = -1 then
    ShowMessage('يجب إختيار الحساب المدين')
  else
  if cbCreditAccount.ItemIndex = -1 then
    ShowMessage('يجب إختيار الحساب الدائن')
  else
  if Trim(edDetails.Text) = '' then
    ShowMessage('لابد من كتابة تفصيل العملية ')
  else
    Result:= True;

end;

procedure TfmAddTrans.Init(Currency: string);
begin
  edValue.Clear;
  edDetails.Clear;
  edDetails.Clear;
  laCurrency.Caption:= Currency;
  with dmData.sqAccounts do
  begin
    Close;
    Open;
    SetLength(AccountIDs, 0);
    cbDebitAccount.Clear;
    cbCreditAccount.Clear;
    while not Eof do
    begin
      cbDebitAccount.Items.Add(FieldByName('AccountName').AsString);
      SetLength(AccountIDs, Length(AccountIDs) + 1);
      AccountIDs[High(AccountIDs)]:= FieldByName('AccountID').AsInteger;
      Next;
    end;
    Close;
    cbCreditAccount.Items.Text:= cbDebitAccount.Items.Text;
  end;
end;


initialization
  {$I addtrans.lrs}

end.

