unit ChangePass;

{$mode objfpc}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons;

type

  { TfmChangePass }

  TfmChangePass = class(TForm)
    bbChange: TBitBtn;
    BitBtn2: TBitBtn;
    edCurrentPass: TEdit;
    edNewPass: TEdit;
    edConfirmPass: TEdit;
    Label1: TLabel;
    laCurrentPass: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    laUser: TLabel;
    procedure bbChangeClick(Sender: TObject);
  private
    { private declarations }
  public
    fAskForOldPassword: Boolean;
    procedure Init(UserName: string; AskForOldPassword: Boolean = True);
    { public declarations }
  end; 

var
  fmChangePass: TfmChangePass;

implementation

{ TfmChangePass }

uses Data;

procedure TfmChangePass.bbChangeClick(Sender: TObject);
var
   Res: AnsiString;
begin
  if edNewPass.Text = '' then
    MessageDlg('لابد من كتابة كلمة مرور', mtError, [mbOk], 0)
  else
  if edNewPass.Text <> edConfirmPass.Text then
    MessageDlg('كلمة المرور غير مطابقة', mtError, [mbOk], 0)
  else
  if fAskForOldPassword and (not dmData.CheckLogin(laUser.Caption, edCurrentPass.Text)) then
    MessageDlg('كلمة المرور الحالية غير صحيحة', mtError, [mbOk], 0)
  else
  if dmData.ChangePassword(laUser.Caption, edNewPass.Text, Res) then
  begin
     if LowerCase(laUser.Caption) = LowerCase(dmData.IBConnection1.UserName) then
        dmData.IBConnection1.UserName:= laUser.Caption;

     MessageDlg('تم تغيير كلمة المرور بنجاح', mtInformation, [mbOk], 0);
     ModalResult:= mrOK;

  end
  else
     MessageDlg('حدث خطأ أثناء تغيير كلمة المرور' + Res, mtError, [mbOk], 0);
end;

procedure TfmChangePass.Init(UserName: string; AskForOldPassword: Boolean);
begin
  fAskForOldPassword:= AskForOldPassword;
  laUser.Caption:= UserName;
  edCurrentPass.Clear;
  edNewPass.Clear;
  edConfirmPass.Clear;
  edCurrentPass.Visible:= AskForOldPassword;
  laCurrentPass.Visible:= AskForOldPassword;
end;

initialization
  {$I changepass.lrs}

end.

