unit Config;

{$mode objfpc}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, DbCtrls, Buttons;

type

  { TfmConfig }

  TfmConfig = class(TForm)
    BitBtn1: TBitBtn;
    cxEnabled: TCheckBox;
    edID: TEdit;
    edTitle: TEdit;
    edRecChequesAccID: TEdit;
    edOrigChequesAccID: TEdit;
    edUnitName: TEdit;
    edUnit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    meDescription: TMemo;
    procedure BitBtn1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure Init;
  end; 

var
  fmConfig: TfmConfig;

implementation

{ TfmConfig }

uses Data, Main;

procedure TfmConfig.BitBtn1Click(Sender: TObject);
begin
  if (Trim(edID.Text) = '') or (Trim(edTitle.Text) = '') or (Trim(edUnit.Text)= '') or (Trim(edUnitName.Text) = '')
  then
    ShowMessage('لابد من ملىء كل الخانات المطلوبة')
  else
  with dmData.sqGeneral do
  begin
    try
      Close;
      SQL.Text:= 'delete from Config';
      ExecSQL;
      SQL.Text:= 'insert into Config (ID, Title, Unit, UnitName, Description, RecChequesAccID, OrigChequesAccID, Enabled) values ' +
        '(:ID, :Title, :Unit, :UnitName, :Description, :RecChequesAccID, :OrigChequesAccID, :Enabled)';
      Params.ParamByName('ID').AsString:= edID.Text;
      Params.ParamByName('Title').AsString:= edTitle.Text;
      Params.ParamByName('Unit').AsString:= edUnit.Text;
      Params.ParamByName('UnitName').AsString:= edUnitName.Text;
      Params.ParamByName('Description').AsString:= meDescription.Lines.Text;
      Params.ParamByName('UnitName').AsString:= edUnitName.Text;
      if Trim(edRecChequesAccID.Text) = '' then
        edRecChequesAccID.Text:= '0';
      if Trim(edOrigChequesAccID.Text) = '' then
        edOrigChequesAccID.Text:= '0';
      Params.ParamByName('RecChequesAccID').AsString:= Trim(edRecChequesAccID.Text);
      Params.ParamByName('OrigChequesAccID').AsString:= Trim(edOrigChequesAccID.Text);
      Params.ParamByName('Enabled').AsBoolean:= cxEnabled.Checked;
      ExecSQL;
      dmData.SQLTransaction1.Commit;
      fmMain.EntityName:= edTitle.Text;
      ModalResult:= mrOK;

    except
    on e: exception do
    begin
      dmData.SQLTransaction1.Rollback;
      MessageDlg('حدث خطأ إثناء حفظ اﻹعدادات: ' + e.Message, mtError, [mbOk], 0);
    end;
  end;

  end;
end;

procedure TfmConfig.Init;
begin
  dmData.sqGeneral.Close;
  dmData.sqGeneral.SQL.Text:= 'select * from Config';
  dmData.sqGeneral.Open;
  with dmData.sqGeneral do
  if RecordCount > 0 then
  begin
    edID.Text:= FieldByName('ID').AsString;
    edTitle.Text:= FieldByName('Title').AsString;
    edUnit.Text:= FieldByName('Unit').AsString;
    edUnitName.Text:= FieldByName('UnitName').AsString;
    meDescription.Lines.Text:= FieldByName('Description').AsString;
    cxEnabled.Checked:= FieldByName('Enabled').AsBoolean;
    edOrigChequesAccID.Text:= FieldByName('OrigChequesAccID').AsString;
    edRecChequesAccID.Text:= FieldByName('RecChequesAccID').AsString;
  end;
  dmData.sqGeneral.Close;
end;

initialization
  {$I config.lrs}

end.

