unit Data;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, IBConnection, sqldb, db, FileUtil, LResources, Forms,
  Controls, Dialogs, ComCtrls;

type

  TAccountIDs = array of Integer;
  { TdmData }

  TdmData = class(TDataModule)
    IBConnection1: TIBConnection;
    IBConnection2: TIBConnection;
    sqAccountsReport: TSQLQuery;
    sqAccountsACCOUNTID: TLongintField;
    sqAccountsACCOUNTNAME: TStringField;
    sqAccountsDESCRIPTION: TStringField;
    sqAccountsENABLED: TSmallintField;
    sqAccountsPARENTACCOUNTID: TLongintField;
    sqBanksBANKID: TLongintField;
    sqBanksBANKNAME: TStringField;
    sqInsertOrigCheque: TSQLQuery;
    sqEditAccountsACCOUNTID: TLongintField;
    sqEditAccountsACCOUNTNAME: TStringField;
    sqEditAccountsDESCRIPTION: TStringField;
    sqEditAccountsENABLED: TSmallintField;
    sqEditAccountsPARENTACCOUNTID: TLongintField;
    sqEntryFormsCREDITACCID: TLongintField;
    sqEntryFormsDEBITACCID: TLongintField;
    sqEntryFormsDEFAULTDETAIL: TStringField;
    sqEntryFormsFORMID: TLongintField;
    sqEntryFormsTITLE: TStringField;
    sqGeneral: TSQLQuery;
    sqAddAccount: TSQLQuery;
    sqAddTrans: TSQLQuery;
    sqAccounts: TSQLQuery;
    sqDailyReport: TSQLQuery;
    sqEntryForms: TSQLQuery;
    sqEditAccounts: TSQLQuery;
    sqGeneral2: TSQLQuery;
    sqInsertOrigChequeTrans: TSQLQuery;
    sqChequeTransHistory: TSQLQuery;
    sqBanks: TSQLQuery;
    sqOrigCheques: TSQLQuery;
    sqOrigChequesACCOUNTNO: TStringField;
    sqOrigChequesBANKNAME: TStringField;
    sqOrigChequesCHEQUEDATE: TDateField;
    sqOrigChequesCHEQUEID: TLongintField;
    sqOrigChequesCHEQUENO: TStringField;
    sqOrigChequesCHEQUEVALUE: TFloatField;
    sqOrigChequesCREDITACCID: TLongintField;
    sqOrigChequesCREDITACCOUNT: TStringField;
    sqOrigChequesDEBITACCID: TLongintField;
    sqOrigChequesDEBITACCOUNT: TStringField;
    sqOrigChequesDETAILS: TStringField;
    sqOrigChequesENTRYDATE: TDateTimeField;
    sqOrigChequesSTATENAME: TStringField;
    sqOrigChequesUSERNAME: TStringField;
    sqReportAccountsACCOUNTID: TLongintField;
    sqReportAccountsREPORTID: TLongintField;
    sqReportsINCLUDEARCHIVE: TSmallintField;
    sqReportsINCLUDEDATE: TSmallintField;
    sqReportsINCLUDEDETAILS: TSmallintField;
    sqReportsREPORTID: TLongintField;
    sqReportsSEARCHTEXT: TStringField;
    sqReportsTITLE: TStringField;
    sqUsers: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    sqReports: TSQLQuery;
    sqReportAccounts: TSQLQuery;
    StringField1: TStringField;
    StringField2: TStringField;
    StringField3: TStringField;
    procedure sqReportAccountsAfterInsert(DataSet: TDataSet);
    procedure StringField1GetText(Sender: TField; var aText: string;
      DisplayText: Boolean);
    procedure StringField2GetText(Sender: TField; var aText: string;
      DisplayText: Boolean);
    procedure StringField3GetText(Sender: TField; var aText: string;
      DisplayText: Boolean);
  private
    procedure FillChilds(AccountID: Integer;  ATree: TTreeView; Node: TTreeNode);
    { private declarations }
  public
    { public declarations }
    function AddNewAccount(AccountName, Description: string; ParentAccountID: Integer): Boolean;
    function InsertTrans(AccountID, EntryID, TransType: Integer; Credit, Debit: Double; Details: string): Boolean;
    function GetEntryID: Integer;
    procedure FillAccountsBox(Items: TStrings; var IDs: TAccountIDs; AFilter: string = '');
    procedure FillAccountsTree(ATree: TTreeView; RootAccountID: Integer = -1; ExpandNodes: Boolean = False);
    procedure GetRootAccounts(var Accounts: TAccountIDs; RootAccountID: Integer = -1);
    function GetChildAccounts(AccountID: Integer; var ChildAccounts: TAccountIDs): Boolean;
    function GetAllChildAccounts(AccountID: Integer): string;
    function GetEntryFormInfo(FormID: Integer; var Title, DefaultDetail: string;
      var CreditAccountID, DebitAccountID: Integer): Boolean;
    function AddNewUser(UserName, FullName, Password, Role: string; CreateInServer: Boolean = True): Boolean;
    function ArchivingIsNeeded: Boolean;
    function DoArchiving: Boolean;
    function CheckLogin(UserName, Password: string): Boolean;
    function ChangePassword(UserName, NewPassword: string; var Res: string): Boolean;
    function UpdateUsername(UserID: Integer; FullUserName: string; var Res: string): Boolean;
    function GrantRoleToUser(UserName, Role: string; var Res: string): Boolean;
    function RemoveUser(UserName: string; RemoveFromServer: Boolean; var Res: string): Boolean;
    function GetOtherDatabaseUsers: string;
    function GetReportInfo(ReportID: Integer; var Title, SearchText: string; var IncludeDetails, IncludeDate, IncludeArchive: Boolean;
      var Accounts: string): Boolean;

    // Cheques
    function InsertOrigCheque(BankID: Integer; ChequeNo, AccountNo: string; CreditAccountID, DebitAccountID, Direction: Integer;
       ChequeValue: Double; ChequeDate: TDateTime; Details: string; var Res: string): Boolean;

    function InsertOrigChequeTrans(ChequeID, StateID: Integer; Details: string; var Res: string): Boolean;

    function UpdateOrigChequeState(ChequeID, StateID: Integer; var Res: string): Boolean;

    procedure FillBanksBox(Items: TStrings; var IDs: TAccountIDs);

    function IsOrigChequeInserted(BankID: Integer; AccountNo, ChequeNo: string): Boolean;

    function DelayCheque(ChequeID: Integer; NewDate: TDateTime; var Res: string): Boolean;

    function ChangeChequeDebitAccID(ChequeID, DebitAccountID: Integer; var Res: string): Boolean;

    function ChangeChequeCreditAccID(ChequeID, CreditAccountID: Integer; var Res: string): Boolean;

    function GetChequeInfo(ChequeID: Integer; var BankID, CreditAccID, DebitAccID, Direction, StateID: Integer; var ChequeNo, AccountNo,
      Details: string; var ChequeValue: Double; var EntryDate, ChequeDate: TDateTime; var Res: string): Boolean;
  end;

var
  dmData: TdmData;

implementation


function TdmData.AddNewAccount(AccountName, Description: string; ParentAccountID: Integer): Boolean;
begin
  try
    sqAddAccount.Params.ParamByName('AccountName').AsString:= Trim(AccountName);
    sqAddAccount.Params.ParamByName('Description').AsString:= Description;
    sqAddAccount.Params.ParamByName('ParentAccountID').AsInteger:= ParentAccountID;
    sqAddAccount.ExecSQL;
    SQLTransaction1.CommitRetaining;
    Result:= True;
  except
  on e: exception do
  begin
    Result:= False;
    ShowMessage('حدث خطأ أثناء إضافة حساب ' + e.message);
  end;
  end;
end;

function TdmData.InsertTrans(AccountID, EntryID, TransType: Integer; Credit, Debit: Double; Details: string): Boolean;
begin
  try
    sqAddTrans.Params.ParamByName('AccountID').AsInteger:= AccountID;
    sqAddTrans.Params.ParamByName('EntryID').AsInteger:= EntryID;
    sqAddTrans.Params.ParamByName('TransType').AsInteger:= TransType;
    sqAddTrans.Params.ParamByName('Credit').AsFloat:= Credit;
    sqAddTrans.Params.ParamByName('Debit').AsFloat:= Debit;
    sqAddTrans.Params.ParamByName('Details').AsString:= Details;
    sqAddTrans.ExecSQL;
    Result:= True;
  except
  on e: exception do
  begin
    Result:= False;
    ShowMessage('حدث خطأ أثناء إضافة القيد ' + e.message);
  end;
  end;
end;

function TdmData.GetEntryID: Integer;
begin
  try
    sqGeneral.Close;
    sqGeneral.SQL.Text:= 'select GEN_ID(EntryIDGen, 1) from RDB$Database';
    sqGeneral.Open;
    Result:= sqGeneral.Fields[0].AsInteger;
    sqGeneral.Close;

  except
  on e: exception do
  begin
    Result:= -1;
    ShowMessage('تعذر الحصول على رقم القيد: ' + e.Message);
  end;

  end;
end;

procedure TdmData.FillAccountsBox(Items: TStrings; var IDs: TAccountIDs; AFilter: string = '');
begin
  with dmData.sqGeneral do
  begin
    Close;
    if AFilter = '' then
      SQL.Text:= 'select * from Accounts where Enabled = 1 order by AccountID'
    else
    begin
      if AFilter[Length(AFilter)] = ',' then
        System.Delete(AFilter, Length(AFilter), 1);

      SQL.Text:= 'select * from Accounts where Enabled = 1 and AccountID in (' + AFilter + ') order by AccountID';
    end;

    Open;
    SetLength(IDs, 0);
    Items.Clear;
    while not Eof do
    begin
      Items.Add(FieldByName('AccountName').AsString);
      SetLength(IDs, Length(IDs) + 1);
      IDs[High(IDs)]:= FieldByName('AccountID').AsInteger;
      Next;
    end;
    Close;
  end;
end;

procedure TdmData.FillBanksBox(Items: TStrings; var IDs: TAccountIDs);
begin
  with dmData.sqGeneral do
  begin
    Close;
    SQL.Text:= 'select * from Banks order by BankID';

    Open;
    SetLength(IDs, 0);
    Items.Clear;
    while not Eof do
    begin
      Items.Add(FieldByName('BankName').AsString);
      SetLength(IDs, Length(IDs) + 1);
      IDs[High(IDs)]:= FieldByName('BankID').AsInteger;
      Next;
    end;
    Close;
  end;
end;

function TdmData.IsOrigChequeInserted(BankID: Integer; AccountNo, ChequeNo: string): Boolean;
begin
  with sqGeneral do
  begin
    Close;
    SQL.Text:= 'select * from Cheques where BankID = :BankID and AccountNo = :AccountNo and ChequeNo = :ChequeNo and ' +
      'StateID in (1, 2)';
    Params.ParamByName('BankID').AsInteger:= BankID;
    Params.ParamByName('AccountNo').AsString:= Trim(AccountNo);
    Params.ParamByName('ChequeNo').AsString:= Trim(ChequeNo);
    Open;
    Result:= RecordCount > 0;
    Close;
  end;
end;

function TdmData.DelayCheque(ChequeID: Integer; NewDate: TDateTime; var Res: string): Boolean;
begin
  try
    sqGeneral.Close;
    sqGeneral.SQL.Text:= 'update Cheques set ChequeDate = :ChequeDate where ChequeID = :ChequeID';
    sqGeneral.Params.ParamByName('ChequeDate').AsDate:= NewDate;
    sqGeneral.Params.ParamByName('ChequeID').AsInteger:= ChequeID;
    sqGeneral.ExecSQL;
    Result:= True;

  except
  on e: exception do
  begin
    Result:= False;
    Res:= e.Message;
  end;

  end;
end;

function TdmData.ChangeChequeDebitAccID(ChequeID, DebitAccountID: Integer; var Res: string): Boolean;
begin
  try
    sqGeneral.Close;
    sqGeneral.SQL.Text:= 'update Cheques set DebitAccID = :DebitAccID where ChequeID = :ChequeID';
    sqGeneral.Params.ParamByName('DebitAccID').AsInteger:= DebitAccountID;
    sqGeneral.Params.ParamByName('ChequeID').AsInteger:= ChequeID;
    sqGeneral.ExecSQL;
    Result:= True;

  except
  on e: exception do
  begin
    Result:= False;
    Res:= e.Message;
  end;

  end;

end;

function TdmData.ChangeChequeCreditAccID(ChequeID, CreditAccountID: Integer; var Res: string): Boolean;
begin
  try
    sqGeneral.Close;
    sqGeneral.SQL.Text:= 'update Cheques set CreditAccID = :CreditAccID where ChequeID = :ChequeID';
    sqGeneral.Params.ParamByName('CreditAccID').AsInteger:= CreditAccountID;
    sqGeneral.Params.ParamByName('ChequeID').AsInteger:= ChequeID;
    sqGeneral.ExecSQL;
    Result:= True;

  except
  on e: exception do
  begin
    Result:= False;
    Res:= e.Message;
  end;

  end;

end;

function TdmData.GetChequeInfo(ChequeID: Integer; var BankID, CreditAccID, DebitAccID, Direction, StateID: Integer;
  var ChequeNo, AccountNo, Details: string; var ChequeValue: Double; var EntryDate, ChequeDate: TDateTime; var Res: string): Boolean;
begin
  try
    sqGeneral.Close;
    sqGeneral.SQL.Text:= 'select * from Cheques where ChequeID = ' + IntToStr(ChequeID);
    sqGeneral.Open;
    Result:= sqGeneral.RecordCount > 0;
    if Result then
    begin
      BankID:= sqGeneral.FieldByName('BankID').AsInteger;
      CreditAccID:= sqGeneral.FieldByName('CreditAccID').AsInteger;
      DebitAccID:= sqGeneral.FieldByName('DebitAccID').AsInteger;
      Direction:= sqGeneral.FieldByName('Direction').AsInteger;
      StateID:= sqGeneral.FieldByName('StateID').AsInteger;
      ChequeNo:= sqGeneral.FieldByName('ChequeNo').AsString;
      AccountNo:= sqGeneral.FieldByName('AccountNo').AsString;
      Details:= sqGeneral.FieldByName('Details').AsString;
      ChequeValue:= sqGeneral.FieldByName('ChequeValue').AsFloat;
      EntryDate:= sqGeneral.FieldByName('EntryDate').AsDateTime;
      ChequeDate:= sqGeneral.FieldByName('ChequeDate').AsDateTime;
    end;
    sqGeneral.Close;

  except
  on e: exception do
  begin
    Result:= False;
    Res:= e.Message;
  end;
  end;
end;

procedure TdmData.StringField1GetText(Sender: TField; var aText: string; DisplayText: Boolean);
begin
  if sqAccounts.Locate('AccountID', sqEntryForms.FieldByName('DebitAccID').AsInteger, []) then
    aText:= sqAccounts.FieldByName('AccountName').AsString;
end;

procedure TdmData.sqReportAccountsAfterInsert(DataSet: TDataSet);
begin
  sqReportAccounts.FieldByName('ReportID').AsInteger:= sqReports.FieldByName('ReportID').AsInteger;
end;

procedure TdmData.StringField2GetText(Sender: TField; var aText: string;
  DisplayText: Boolean);
begin
  if sqAccounts.Locate('AccountID', sqEntryForms.FieldByName('CreditAccID').AsInteger, []) then
    aText:= sqAccounts.FieldByName('AccountName').AsString;
end;

procedure TdmData.StringField3GetText(Sender: TField; var aText: string;
  DisplayText: Boolean);
begin
  if sqAccounts.Locate('AccountID', sqReportAccounts.FieldByName('AccountID').AsInteger, []) then
    aText:= sqAccounts.FieldByName('AccountName').AsString;

end;

procedure TdmData.FillChilds(AccountID: Integer; ATree: TTreeView; Node: TTreeNode);
var
  ChildNode: TTreeNode;
  ChildAccounts: TAccountIDs;
  j: Integer;
begin
  if sqAccounts.Locate('AccountID', AccountID, []) then
  begin
    ChildNode:= ATree.Items.AddChild(Node, sqAccounts.FieldByName('AccountName').AsString);
    ChildNode.OverlayIndex:= AccountID;
    ChildNode.ImageIndex:= 1;
    ChildNode.SelectedIndex:= 1;

    if GetChildAccounts(AccountID, ChildAccounts) then
      for j:= 0 to High(ChildAccounts) do
        FillChilds(ChildAccounts[j], ATree, ChildNode);

  end;
end;

procedure TdmData.FillAccountsTree(ATree: TTreeView; RootAccountID: Integer = -1; ExpandNodes: Boolean = False);

var
  RootAccounts, ChildAccounts: TAccountIDs;
  i, j: Integer;
  Node: TTreeNode;
begin
  ATree.Items.Clear;
  ATree.AutoExpand:= ExpandNodes;
  GetRootAccounts(RootAccounts, RootAccountID);
  sqAccounts.Close;
  sqAccounts.Open;
  for i:= 0 to high(RootAccounts) do
    with sqAccounts do
    begin
      if Locate('AccountID', RootAccounts[i], []) then
      begin
        // Root accounts
        Node:= ATree.Items.Add(nil, FieldByName('AccountName').AsString);
        Node.OverlayIndex:= RootAccounts[i];
        Node.ImageIndex:= 0;
        Node.SelectedIndex:= 0;

        // Child accounts
        if GetChildAccounts(RootAccounts[i], ChildAccounts) then
        for j:= 0 to High(ChildAccounts) do
          FillChilds(ChildAccounts[j], ATree, Node);
      end;
    end;
  sqAccounts.Close;
end;

procedure TdmData.GetRootAccounts(var Accounts: TAccountIDs; RootAccountID: Integer = -1);
var
  i: Integer;
begin
  sqGeneral.Close;
  sqGeneral.SQL.Text:= 'select AccountID from Accounts where ';

  if RootAccountID = -1 then
    sqGeneral.sql.Add(' ParentAccountID = 0')
  else
    sqGeneral.SQL.Add('AccountID = ' + IntToStr(RootAccountID));

  sqGeneral.Open;
  SetLength(Accounts, 0);
  i:= 0;
  with sqGeneral do
  while not EOF do
  begin
    Inc(i);
    SetLength(Accounts, i);
    Accounts[i - 1]:= Fields[0].AsInteger;
    Next;
  end;
  sqGeneral.Close;
end;

function TdmData.GetChildAccounts(AccountID: Integer; var ChildAccounts: TAccountIDs): Boolean;
var
  i: Integer;
begin
  Result:= False;
  sqGeneral.Close;
  sqGeneral.SQL.Text:= 'select AccountID from Accounts where ParentAccountID = ' + IntToStr(AccountID);
  sqGeneral.Open;
  SetLength(ChildAccounts, 0);
  i:= 0;
  with sqGeneral do
  while not EOF do
  begin
    Result:= True;
    Inc(i);
    SetLength(ChildAccounts, i);
    ChildAccounts[i - 1]:= Fields[0].AsInteger;
    Next;
  end;
  sqGeneral.Close;
end;

function TdmData.GetAllChildAccounts(AccountID: Integer): string;
var
  ChildAccounts: TAccountIDs;
  i: Integer;
begin
  if GetChildAccounts(AccountID, ChildAccounts) then
  begin
    for i:= 0 to High(ChildAccounts) do
      Result:= Result + IntToStr(ChildAccounts[i]) + ',';

    // Descendants
    for i:= 0 to High(ChildAccounts) do
    begin
      Result:= Result + GetAllChildAccounts(ChildAccounts[i]);
    end;

  end;

end;

function TdmData.GetEntryFormInfo(FormID: Integer; var Title, DefaultDetail: string;
    var CreditAccountID, DebitAccountID: Integer): Boolean;
begin
  sqGeneral.Close;
  sqGeneral.SQL.Text:= 'select * from EntryForms where FormID = ' + IntToStr(FormID);
  sqGeneral.Open;
  Result:= sqGeneral.RecordCount > 0;
  if Result then
  with sqGeneral do
  begin
    Title:= FieldByName('Title').AsString;
    CreditAccountID:= FieldByName('CreditAccID').AsInteger;
    DebitAccountID:= FieldByName('DebitAccID').AsInteger;
    DefaultDetail:= FieldByName('DefaultDetail').AsString;
  end;
  sqGeneral.Close;
end;

function TdmData.AddNewUser(UserName, FullName, Password, Role: string; CreateInServer: Boolean = True): Boolean;
begin
  try
    sqGeneral.Close;
    if CreateInServer then
    begin
      sqGeneral.SQL.Text:='create user ' + UserName + ' password ''' + Password + ''';';
      sqGeneral.ExecSQL;
    end;

    sqGeneral.SQL.Text:= 'insert into Users (Login, FullName, Role) values (:Login, :FullName, :Role)';
    sqGeneral.Params.ParamByName('Login').AsString:= UserName;
    sqGeneral.Params.ParamByName('FullName').AsString:= FullName;
    sqGeneral.Params.ParamByName('Role').AsString:= Role;
    sqGeneral.ExecSQL;

    if Role <> '' then
    begin
      sqGeneral.SQL.Text:= 'grant ' + Role + ' to ' + UserName;
      if LowerCase(Role) = 'adminrole' then
      begin
        sqGeneral.SQL.Add(' with admin option;');
        sqGeneral.ExecSQL;
        sqGeneral.SQL.Text:= 'grant AccRole to ' + UserName + ' with admin option;';
      end;

      sqGeneral.ExecSQL;

      sqGeneral.SQL.Text:= 'grant select on Users to ' + UserName;
      if LowerCase(Role) = 'adminrole' then
        sqGeneral.SQL.Add(' with grant option;');
      sqGeneral.ExecSQL;
      SQLTransaction1.Commit;
    end;

    Result:= True;

  except
  on e: exception do
  begin
    MessageDlg('خطأ أثناء إضافة مستخدم: ' + e.Message, mtError, [mbOK], 0);
    Result:= False;
  end;

  end;
end;

function TdmData.ArchivingIsNeeded: Boolean;
var
  Year, Month, Day: Word;
begin
  DecodeDate(Now, Year, Month, Day);
  sqGeneral.Close;
  sqGeneral.SQL.Text:= 'select first 1 * from Trans where TransTime < :CurrYear';
  sqGeneral.Params.ParamByName('CurrYear').Value:= EncodeDate(Year, 1, 1);
  sqGeneral.Open;
  Result:= sqGeneral.RecordCount > 0;
  sqGeneral.Close;
end;

function TdmData.DoArchiving: Boolean;
var
  Accounts: array of Integer;
  i: Integer;
  Year, Month, Day: Word;
  Net, CreditTotal, DebitTotal: Double;
begin

  try
    // Get all accounts
    sqGeneral.Close;
    sqGeneral.SQL.Text:= 'select AccountID from Accounts';
    sqGeneral.Open;
    SetLength(Accounts, 0);
    i:= 0;
    with sqGeneral do
    while not Eof do
    begin
      SetLength(Accounts, i + 1);
      Accounts[i]:= sqGeneral.Fields[0].AsInteger;
      Inc(i);
      Next;
    end;
    sqGeneral.Close;

    DecodeDate(Date, Year, Month, Day);
    // Get summation for accounts individually
    for i:= 0 to High(Accounts) do
    begin
      sqGeneral.SQL.Text:= 'select sum(Credit) as Credit, Sum(Debit) as Debit from Trans where AccountID = ' +
        IntToStr(Accounts[i]) + ' and TransTime < :CurrYear';
      sqGeneral.Params.ParamByName('CurrYear').AsDateTime:= EncodeDate(Year, 1, 1);
      sqGeneral.Open;
      CreditTotal:= sqGeneral.FieldByName('Credit').AsFloat;
      DebitTotal:= sqGeneral.FieldByName('Debit').AsFloat;
      sqGeneral.close;

      // Insert summation
      if (CreditTotal <> 0) or (DebitTotal <> 0) then
      begin
        Net:= DebitTotal - CreditTotal;
        CreditTotal:= 0;
        DebitTotal:= 0;
        if Net > 0 then
          DebitTotal:= Net
        else
          CreditTotal:= Abs(Net);
        InsertTrans(Accounts[i], 0, 10, CreditTotal, DebitTotal, 'مُرحل من عام ' + IntToStr(Year - 1));
      end;

      // Delete last year details
      sqGeneral.SQL.Text:= 'delete from Trans where AccountID = ' + IntToStr(Accounts[i]) + ' and TransTime < :CurrYear';
      sqGeneral.Params.ParamByName('CurrYear').AsDateTime:= EncodeDate(Year, 1, 1);
      sqGeneral.ExecSQL;

      // Delete cheque transactions
      sqGeneral.SQL.Text:= 'delete from CHEQUETRANS where TransTime < :CurrYear';
      sqGeneral.Params.ParamByName('CurrYear').AsDateTime:= EncodeDate(Year, 1, 1);
      sqGeneral.ExecSQL;

      sqGeneral.SQL.Text:= 'delete from CHEQUES where StateID <> 1 and ChequeDate < :CurrYear';
      sqGeneral.Params.ParamByName('CurrYear').AsDateTime:= EncodeDate(Year, 1, 1);
      sqGeneral.ExecSQL;

      SQLTransaction1.Commit;

    end;
    Result:= True;

  except
  on e: exception do
  begin
    Result:= False;
    MessageDlg('حدثت مشكلة أثناء الترحيل، ربما تكون بعد الحسابات قد تم ترحيلها بنجاح' + #10 + e.Message,
      mtError, [mbOk], 0);
  end;

  end;
end;

function TdmData.CheckLogin(UserName, Password: string): Boolean;
begin
  try
    IBConnection2.Close;
    IBConnection2.DatabaseName:= IBConnection1.DatabaseName;
    IBConnection2.UserName:= UserName;
    IBConnection2.Password:= Password;
    IBConnection2.Connected:= True;
    Result:= IBConnection2.Connected;
    IBConnection2.Close;

  except
  on e: exception do
    Result:= False;
  end;
end;

function TdmData.ChangePassword(UserName, NewPassword: string; var Res: string): Boolean;
begin
  try
    sqGeneral.Close;
    sqGeneral.SQL.Text:= 'alter user ' + UserName + ' password ''' + NewPassword + '''';
    sqGeneral.ExecSQL;
    SQLTransaction1.Commit;
    Result:= True;

  except
  on e: exception do
  begin
    Res:= e.Message;
    Result:= False;
  end;

  end;
end;

function TdmData.UpdateUsername(UserID: Integer; FullUserName: string; var Res: string): Boolean;
begin
  try
    with sqGeneral do
    begin
      Close;
      sql.Text:= 'update Users set FullName = :FullName where UserID = ' + IntToStr(UserID);
      Params.ParamByName('FullName').AsString:= FullUserName;
      ExecSQL;
      SQLTransaction1.Commit;
      Result:= True;
    end;

  except
  on e: exception do
  begin
    Result:= False;
    Res:= e.Message;
  end;

  end;
end;

function TdmData.GrantRoleToUser(UserName, Role: string; var Res: string): Boolean;
begin
  try
     // Modify Users table
    sqGeneral.SQL.Text:= 'update Users set Role = :Role where Login = ''' + UserName + '''';
    sqGeneral.Params.ParamByName('Role').AsString:= Role;
    sqGeneral.ExecSQL;

    sqGeneral.SQL.Text:= 'grant ' + Role + ' to ' + UserName;
    if LowerCase(Role) = 'adminrole' then
    begin
      sqGeneral.SQL.Add(' with admin option;');
      sqGeneral.ExecSQL;
      sqGeneral.SQL.Text:= 'grant AccRole to ' + UserName + ' with admin option;';
    end
    else
    begin
      sqGeneral.ExecSQL;
      sqGeneral.SQL.Text:='revoke AdminRole from ' + UserName + ';';
    end;

    sqGeneral.ExecSQL;

    sqGeneral.SQL.Text:= 'grant select on Users to ' + UserName;
    if LowerCase(Role) = 'adminrole' then
      sqGeneral.SQL.Add(' with grant option;');

    sqGeneral.ExecSQL;

    SQLTransaction1.Commit;

  except
  on e: exception do
  begin
    Result:= False;
    Res:= E.Message;
  end;

  end;
end;

function TdmData.RemoveUser(UserName: string; RemoveFromServer: Boolean;var Res: string): Boolean;
var
  UserID: Integer;
  Role: string;
begin
  try
    sqGeneral.Close;
    sqGeneral.SQL.Text:= 'select UserID, Role from Users where Login = ''' + UserName + '''';
    sqGeneral.Open;
    if sqGeneral.RecordCount > 0 then
    begin
      UserID:= sqGeneral.FieldByName('UserID').AsInteger;
      Role:= sqGeneral.FieldByName('Role').AsString;
      sqGeneral.Close;

      // Remove role
      if (not RemoveFromServer) and (Role <> '') then
      begin
        sqGeneral.SQL.Text:= 'revoke ' + Role + ' from ' + UserName;
        sqGeneral.ExecSQL;
      end;

      // Remove user from database
      sqGeneral.SQL.Text:= 'delete from Users where UserID = ' + IntToStr(UserID);
      sqGeneral.ExecSQL;

    end;
    sqGeneral.Close;

    // Remove user from server
    if RemoveFromServer then
    begin
      sqGeneral.SQL.Text:='drop user ' + UserName;
      sqGeneral.ExecSQL;
    end;
    SQLTransaction1.Commit;
    Result:= True;

  except
  on e: exception do
  begin
    Result:= False;
    Res:= E.Message;
  end;

  end;
end;

function TdmData.GetOtherDatabaseUsers: string;
var
  dbUsersList: TStringList;
begin
  dbUsersList:= TStringList.Create;
  sqGeneral.Close;
  sqGeneral.SQL.Text:= 'select Login from Users';
  sqGeneral.Open;

  with sqGeneral do
  while not EOF do
  begin
    dbUsersList.Add(Fields[0].AsString);
    Next;
  end;

  // get db users
  sqGeneral.Close;
  sqGeneral.SQL.Text:= 'select distinct RDB$User, RDB$User_Type from RDB$USER_PRIVILEGES';
  sqGeneral.Open;
  with sqGeneral do
  while not Eof do
  begin
    if Fields[1].AsInteger <> 13 then
    if dbUsersList.IndexOf(Trim(Fields[0].AsString)) = -1 then
      Result:= Result + Trim(Fields[0].AsString) + ',';
    Next;
  end;
  sqGeneral.Close;
  if Result <> '' then
    Delete(Result, Length(Result), 1);

end;

function TdmData.GetReportInfo(ReportID: Integer; var Title, SearchText: string;
  var IncludeDetails, IncludeDate, IncludeArchive: Boolean; var Accounts: string): Boolean;
begin
  sqGeneral.Close;
  sqGeneral.SQL.Text:= 'select * from Reports where ReportID = ' + IntToStr(ReportID);
  sqGeneral.Open;
  Result:= sqGeneral.RecordCount > 0;
  if Result then
  with sqGeneral do
  begin
    Title:= FieldByName('Title').AsString;
    SearchText:= FieldByName('SearchText').AsString;
    IncludeDate:= FieldByName('IncludeDate').AsInteger = 1;
    IncludeArchive:= FieldByName('IncludeArchive').AsInteger = 1;
    IncludeDetails:= FieldByName('IncludeDetails').AsInteger = 1;

    // Accounts
    Close;
    sqGeneral2.Close;
    sqGeneral2.SQL.Text:= 'select AccountID from ReportAccounts where ReportID = ' + IntToStr(ReportID);
    sqGeneral2.Open;
    Result:= sqGeneral2.RecordCount > 0;
    Accounts:= '';

    if Result then
    while not sqGeneral2.Eof do
    begin
      Accounts:= Accounts + sqGeneral2.Fields[0].AsString + ',';
      Accounts:= Accounts + GetAllChildAccounts(sqGeneral2.Fields[0].AsInteger);
      sqGeneral2.Next;
    end;
    if Accounts <> '' then
      System.Delete(Accounts, Length(Accounts), 1);
    sqGeneral2.Close;
  end;
end;

function TdmData.InsertOrigCheque(BankID: Integer; ChequeNo, AccountNo: string;
  CreditAccountID, DebitAccountID, Direction: Integer; ChequeValue: Double;
  ChequeDate: TDateTime; Details: string; var Res: string): Boolean;
var
  ChequeID: Integer;
  EntiryID: Integer;
begin
  try
    sqGeneral.Close;
    sqGeneral.SQL.Text:= 'select Gen_ID(Cheques_ChequeID_Gen, 1) from rdb$database';
    sqGeneral.Open;
    ChequeID:= sqGeneral.Fields[0].AsInteger;
    sqGeneral.Close;

    // Insert into Cheques
    sqInsertOrigCheque.Params.ParamByName('ChequeID').AsInteger:= ChequeID;
    sqInsertOrigCheque.Params.ParamByName('BankID').AsInteger:= BankID;
    sqInsertOrigCheque.Params.ParamByName('ChequeNo').AsString:= ChequeNo;
    sqInsertOrigCheque.Params.ParamByName('AccountNo').AsString:= AccountNo;
    sqInsertOrigCheque.Params.ParamByName('CreditAccID').AsInteger:= CreditAccountID;
    sqInsertOrigCheque.Params.ParamByName('DebitAccID').AsInteger:= DebitAccountID;
    sqInsertOrigCheque.Params.ParamByName('ChequeValue').AsFloat:= ChequeValue;
    sqInsertOrigCheque.Params.ParamByName('Direction').AsInteger:= Direction;
    sqInsertOrigCheque.Params.ParamByName('ChequeDate').AsFloat:= ChequeDate;
    sqInsertOrigCheque.Params.ParamByName('Details').AsString:= Details;
    sqInsertOrigCheque.ExecSQL;

    // Insert into ChequeTrans
    InsertOrigChequeTrans(ChequeID, 1, '', Res);

    // Insert transaction
    EntiryID:= GetEntryID;
    InsertTrans(CreditAccountID, EntiryID, 1, ChequeValue, 0, Details);
    InsertTrans(DebitAccountID, EntiryID, 1, 0, ChequeValue, Details);

    Result:= True;


  except
  on e: exception do
  begin
    Result:= False;
    Res:= e.Message;
  end;

  end;
end;

function TdmData.InsertOrigChequeTrans(ChequeID, StateID: Integer; Details: string; var Res: string): Boolean;
begin
  try

    // Insert into ChequeTrans
    sqInsertOrigChequeTrans.Params.ParamByName('ChequeID').AsInteger:= ChequeID;
    sqInsertOrigChequeTrans.Params.ParamByName('StateID').AsInteger:= StateID;
    sqInsertOrigChequeTrans.Params.ParamByName('Details').AsString:= Details;
    sqInsertOrigChequeTrans.ExecSQL;
    Result:= True


  except
  on e: exception do
  begin
    Result:= False;
    Res:= e.Message;
  end;

  end;
end;

function TdmData.UpdateOrigChequeState(ChequeID, StateID: Integer; var Res: string): Boolean;
begin
  try
    sqGeneral.Close;
    sqGeneral.SQL.Text:= 'update Cheques set StateID = ' + IntToStr(StateID) + ', UpdatedTime = current_timestamp' +
      ' where ChequeID = ' + IntToStr(ChequeID);
    sqGeneral.ExecSQL;
    SQLTransaction1.Commit;
    Result:= True;

  except
  on e: exception do
  begin
    Result:= False;
    Res:= e.Message;
  end;

  end;
end;


initialization
  {$I data.lrs}

end.

