unit DateDialog;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, EditBtn, Buttons, Data;

type

  { TfmDateDialog }

  TfmDateDialog = class(TForm)
    bbBrowse: TBitBtn;
    bbCancel: TBitBtn;
    bbSelect: TBitBtn;
    cbAccount: TComboBox;
    deFromDate: TDateEdit;
    deToDate: TDateEdit;
    Label1: TLabel;
    Label2: TLabel;
    laAccount: TLabel;
    procedure bbBrowseClick(Sender: TObject);
    procedure bbSelectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    AccountIDs: TAccountIDs;
    { private declarations }
  public
    SelectedAccountID: Integer;
    procedure Init(ShowAccounts: Boolean);
    { public declarations }
  end; 

var
  fmDateDialog: TfmDateDialog;

implementation

{ TfmDateDialog }

uses AccountsTree;

procedure TfmDateDialog.FormCreate(Sender: TObject);
begin
  deFromDate.Date:= Date;
  deToDate.Date:= Date;
end;

procedure TfmDateDialog.bbBrowseClick(Sender: TObject);
var
  i: Integer;
begin
  fmAccountsTree.Init(-1, True, False);

  if fmAccountsTree.ShowModal = mrOK then
  begin
    for i:= 0 to High(AccountIDs) do
      if fmAccountsTree.SelectedAccountID = AccountIDs[i] then
      begin
        cbAccount.ItemIndex:= i;
        Break;
      end;
  end;

end;

procedure TfmDateDialog.bbSelectClick(Sender: TObject);
begin
  if cbAccount.Visible then
    SelectedAccountID:= AccountIDs[cbAccount.ItemIndex];
end;

procedure TfmDateDialog.Init(ShowAccounts: Boolean);
var
  Filter: string;
begin
  cbAccount.Visible:= ShowAccounts;
  laAccount.Visible:= ShowAccounts;
  bbBrowse.Visible:= ShowAccounts;
  if ShowAccounts then;
    dmData.FillAccountsBox(cbAccount.Items, AccountIDs);
end;

initialization
  {$I datedialog.lrs}

end.

