unit EditEntities;

{$mode objfpc}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  DBGrids, DbCtrls, Buttons, memds, db;

type

  { TfmEditEntities }

  TfmEditEntities = class(TForm)
    BitBtn1: TBitBtn;
    bbBrowse: TBitBtn;
    Datasource1: TDatasource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    mdsEntities: TMemDataset;
    OpenDialog1: TOpenDialog;
    procedure bbBrowseClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure mdsEntitiesBeforeInsert(DataSet: TDataSet);
  private
    { private declarations }
  public
    procedure Init;
    { public declarations }
  end; 

var
  fmEditEntities: TfmEditEntities;

implementation

{ TfmEditEntities }

procedure TfmEditEntities.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
  mdsEntities.Close;
end;

procedure TfmEditEntities.mdsEntitiesBeforeInsert(DataSet: TDataSet);
begin
  mdsEntities.FieldByName('ID').AsInteger:= mdsEntities.RecNo;
end;

procedure TfmEditEntities.BitBtn1Click(Sender: TObject);
begin
  if mdsEntities.State in [dsInsert, dsEdit] then
    mdsEntities.Post;

  mdsEntities.SaveToFile(ChangeFileExt(ParamStr(0), '.ent'), True);
end;

procedure TfmEditEntities.bbBrowseClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    begin
      if not (mdsEntities.State in [dsInsert, dsEdit]) then
        mdsEntities.Edit;
      mdsEntities.FieldByName('Database').AsString:= OpenDialog1.FileName;
    end;
end;

procedure TfmEditEntities.FormActivate(Sender: TObject);
begin
  if mdsEntities.RecordCount = 0 then
    begin
      mdsEntities.Append;
      mdsEntities.Fields[0].AsInteger:= 1;
    end;
end;

procedure TfmEditEntities.Init;
var
  AFileName: string;
begin
  AFileName:= ChangeFileExt(ParamStr(0), '.ent');
  if FileExists(AFileName) then
    mdsEntities.LoadFromFile(AFileName);
  mdsEntities.Open;
end;

initialization
  {$I editentities.lrs}

end.

