unit EditReports;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, FileUtil, LResources, Forms, Controls, Graphics,
  Dialogs, DbCtrls, DBGrids, Buttons;

type

  { TfmEditReports }

  TfmEditReports = class(TForm)
    bbSave: TBitBtn;
    bbSave1: TBitBtn;
    Datasource1: TDatasource;
    Datasource2: TDatasource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DBNavigator1: TDBNavigator;
    DBNavigator2: TDBNavigator;
    procedure bbSave1Click(Sender: TObject);
    procedure bbSaveClick(Sender: TObject);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
  private
    { private declarations }
  public
    { public declarations }
    procedure Init;
    procedure GetReportAccounts;
  end; 

var
  fmEditReports: TfmEditReports;

implementation

{ TfmEditReports }

uses Data;

procedure TfmEditReports.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
  dmData.sqReports.Close;
  dmData.sqReportAccounts.Close;
  dmData.sqAccounts.Close;
end;

procedure TfmEditReports.bbSaveClick(Sender: TObject);
var
  RecNo: Integer;
begin
  RecNo:= dmdata.sqReports.RecNo;
  dmData.sqReports.ApplyUpdates;
  dmData.SQLTransaction1.Commit;
  dmData.sqAccounts.Open;
  dmData.sqReports.Open;
  dmData.sqReports.RecNo:= RecNo;
  GetReportAccounts;
end;

procedure TfmEditReports.bbSave1Click(Sender: TObject);
var
  RecNo: Integer;
begin
  RecNo:= dmdata.sqReports.RecNo;
  dmData.sqReportAccounts.ApplyUpdates;
  dmData.SQLTransaction1.Commit;
  dmData.sqAccounts.Open;
  dmData.sqReports.Open;
  dmData.sqReports.RecNo:= RecNo;
  GetReportAccounts;
end;

procedure TfmEditReports.DBGrid1CellClick(Column: TColumn);
begin
  GetReportAccounts;
end;

procedure TfmEditReports.Init;
begin
  dmData.sqReports.Close;
  dmData.sqReports.Open;
  dmData.sqAccounts.Open;
  GetReportAccounts;
end;

procedure TfmEditReports.GetReportAccounts;
begin
  with dmData, dmData.sqReportAccounts do
  begin
    Close;
    if (not sqReports.FieldByName('ReportID').IsNull) and
       (sqReports.FieldByName('ReportID').AsInteger <> 0) then
    begin
      Params.ParamByName('ReportID').AsInteger:= sqReports.FieldByName('ReportID').AsInteger;
      Open;
    end;

  end;
end;

initialization
  {$I editreports.lrs}

end.

