unit GeneralReport;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  RLReport, db;

type

  { TfmGeneralReport }

  TfmGeneralReport = class(TForm)
    Datasource1: TDatasource;
    laAccountTitle: TRLLabel;
    laAccountTitle1: TRLLabel;
    laAccountTitle2: TRLLabel;
    laAccountTitle3: TRLLabel;
    laAccountTitle5: TRLLabel;
    laFrom: TRLLabel;
    laAccountTitle4: TRLLabel;
    laTo: TRLLabel;
    laNet: TRLLabel;
    laDebitTotal: TRLLabel;
    laCreditTotal: TRLLabel;
    laAccount: TRLLabel;
    lrDate: TRLLabel;
    RLBand1: TRLBand;
    RLBand2: TRLBand;
    RLBand3: TRLBand;
    RLBand4: TRLBand;
    RLBand5: TRLBand;
    RLDBText1: TRLDBText;
    RLDBText2: TRLDBText;
    RLDBText3: TRLDBText;
    RLDBText4: TRLDBText;
    RLDBText5: TRLDBText;
    RLDBText6: TRLDBText;
    RLDBText7: TRLDBText;
    RLLabel1: TRLLabel;
    RLLabel3: TRLLabel;
    RLLabel4: TRLLabel;
    RLLabel5: TRLLabel;
    RLLabel6: TRLLabel;
    RLLabel7: TRLLabel;
    RLLabel8: TRLLabel;
    RLReport1: TRLReport;
    RLSystemInfo1: TRLSystemInfo;
    RLSystemInfo2: TRLSystemInfo;
    rlTitle: TRLLabel;
    procedure lrDateBeforePrint(Sender: TObject; var OutputText: string;
      var PrintIt: boolean);
    procedure RLBand3BeforePrint(Sender: TObject; var PrintIt: boolean);
    procedure RLDBText2BeforePrint(Sender: TObject; var OutputText: string;
      var PrintIt: boolean);
    procedure RLDBText6BeforePrint(Sender: TObject; var OutputText: string;
      var PrintIt: boolean);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  fmGeneralReport: TfmGeneralReport;

implementation

{ TfmGeneralReport }

procedure TfmGeneralReport.RLBand3BeforePrint(Sender: TObject;
  var PrintIt: boolean);
begin
  if Datasource1.DataSet.FieldByName('EntryID').AsInteger = 0 then
    RLBand3.Color:= $FFEEEE
  else
    if Datasource1.DataSet.FieldByName('EntryID').AsInteger mod 2 = 0 then
      RLBand3.Color:= $EEEEEE
    else
      RLBand3.Color:= clWhite;
end;

procedure TfmGeneralReport.RLDBText2BeforePrint(Sender: TObject;
  var OutputText: string; var PrintIt: boolean);
begin
  if Pos('.', OutputText) > 0 then
    OutputText:= Format('%3.2n', [Datasource1.DataSet.FieldByName('Debit').AsFloat]);
end;

procedure TfmGeneralReport.RLDBText6BeforePrint(Sender: TObject;
  var OutputText: string; var PrintIt: boolean);
begin
  if Pos('.', OutputText) > 0 then
    OutputText:= Format('%3.2n', [Datasource1.DataSet.FieldByName('Credit').AsFloat]);
end;

procedure TfmGeneralReport.lrDateBeforePrint(Sender: TObject;
  var OutputText: string; var PrintIt: boolean);
begin
  OutputText:= FormatDateTime('yyyy-mm-dd hh:nn', Now);
end;

initialization
  {$I generalreport.lrs}

end.

