unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Buttons, ExtCtrls, StdCtrls, ComCtrls, {LR_Class, LR_DBSet, LR_DSet,}
  HejriUtils, db, LCLIntf, EditBtn, DBGrids;

type

  { TfmMain }

  TfmMain = class(TForm)
    bbAccountsTree: TBitBtn;
    bbAddAccount: TBitBtn;
    bbAddEntry: TBitBtn;
    bbAddNewUser: TBitBtn;
    bbAccountsReport: TBitBtn;
    bbAddOrigCheque: TBitBtn;
    bbChart: TBitBtn;
    bbChequeHistoryReport: TBitBtn;
    bbBackup: TBitBtn;
    bbGetCheques: TBitBtn;
    bbChequesReport: TBitBtn;
    bbPayCheque: TBitBtn;
    bbChequeRD: TBitBtn;
    bbWithdrawCheque: TBitBtn;
    bbDelayCheque: TBitBtn;
    bbEditBanks: TBitBtn;
    bbUsersManage: TBitBtn;
    bbChangePass: TBitBtn;
    bbArchive: TBitBtn;
    bbDailyReport: TBitBtn;
    bbEditAccounts: TBitBtn;
    bbEditEntryForms: TBitBtn;
    bbEditIdentity: TBitBtn;
    bbReportsManage: TBitBtn;
    cbBanks: TComboBox;
    cbChequeTypes: TComboBox;
    cbChequeState: TComboBox;
    cxChequeDate: TCheckBox;
    cxOrigBanks: TCheckBox;
    Datasource1: TDatasource;
    DBGrid1: TDBGrid;
    deOrigChequeDate: TDateEdit;
    laHejri: TLabel;
    laDate: TLabel;
    laURL: TLabel;
    laVersion: TLabel;
    laWeekDay: TLabel;
    PageControl1: TPageControl;
    PageControl2: TPageControl;
    Panel1: TPanel;
    paTop: TPanel;
    paTemplates: TPanel;
    stEntity: TStaticText;
    stEntityDetails: TStaticText;
    tsCheques: TTabSheet;
    tsEntry: TTabSheet;
    tsReports: TTabSheet;
    tsManage: TTabSheet;
    tsMain: TTabSheet;
    procedure bbAccountsReportClick(Sender: TObject);
    procedure bbAccountsTreeClick(Sender: TObject);
    procedure bbAddAccountClick(Sender: TObject);
    procedure bbAddEntryClick(Sender: TObject);
    procedure bbAddOrigChequeClick(Sender: TObject);
    procedure bbBackupClick(Sender: TObject);
    procedure bbChartClick(Sender: TObject);
    procedure bbChequeHistoryReportClick(Sender: TObject);
    procedure bbChequesReportClick(Sender: TObject);
    procedure bbEditBanksClick(Sender: TObject);
    procedure bbGetChequesClick(Sender: TObject);
    procedure bbPayChequeClick(Sender: TObject);
    procedure bbChequeRDClick(Sender: TObject);
    procedure bbWithdrawChequeClick(Sender: TObject);
    procedure bbDelayChequeClick(Sender: TObject);
    procedure bbGetOrigCheques5Click(Sender: TObject);
    procedure bbReportsManageClick(Sender: TObject);
    procedure bbUsersManageClick(Sender: TObject);
    procedure bbAddNewUserClick(Sender: TObject);
    procedure bbArchiveClick(Sender: TObject);
    procedure bbChangePassClick(Sender: TObject);
    procedure bbDailyReportClick(Sender: TObject);
    procedure bbDailyReportMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure bbDailyReportMouseLeave(Sender: TObject);
    procedure bbDailyReportMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure bbEditAccountsClick(Sender: TObject);
    procedure bbEditEntryFormsClick(Sender: TObject);
    procedure bbEditIdentityClick(Sender: TObject);
    procedure cbBanksChange(Sender: TObject);
    procedure cbChequeTypesChange(Sender: TObject);
    procedure cxOrigBanksClick(Sender: TObject);
    procedure cxChequeDateChange(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure deOrigChequeDateChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure frDBDataSet2CheckEOF(Sender: TObject; var Eof: Boolean);
    procedure laURLClick(Sender: TObject);
    procedure tsChequesEnter(Sender: TObject);
    procedure tsChequesExit(Sender: TObject);
    procedure tsEntryResize(Sender: TObject);
    procedure tsReportsEnter(Sender: TObject);
    procedure tsReportsResize(Sender: TObject);
  private
    Activated: Boolean;
    EntryButtonsArray: array of TBitBtn;
    ReportButtonsArray: array of TBitBtn;
    EntityEnabled: Boolean;
    BankIDs: array of Integer;

    procedure CreateEntryButtons;
    procedure CreateReportButtons;
    procedure EntryFormClick(Sender: TObject);
    procedure ReportClick(Sender: TObject);
    procedure ReleaseEntryButtons;
    procedure ReleaseReportButtons;
    procedure ReOrganizeButtons;
    procedure ReOrganizeReportButtons;
    { private declarations }
  public
    EntityName: string;
    Currency: string;
    CurrencyDetail: string;
    OrigChequesAccID: Integer;
    RecChequesAccID: Integer;
    procedure Init;
    { public declarations }
  end; 

var
  fmMain: TfmMain;

implementation

uses Pass, AddTrans, AddAccount, SelDate, Data, AccountsTree, EntryForm, EditEntryForms, EditAccounts, Config, AddUser,
     ChangePass, Users, EditReports, DateDialog, SelAccounts, InsertCheque, ChequesReport, ModifyCheque, ChequeHistoryReport,
     AccountsReport, EditBanks, GeneralReport, BackupDatabase, ChartReport;

{ TfmMain }

procedure TfmMain.FormActivate(Sender: TObject);
begin
  if not Activated then
  begin
    if fmPass.ShowModal = mrOk then
      Init
    else
      Close;

    Activated:= True;
  end;
end;

procedure TfmMain.bbAddEntryClick(Sender: TObject);
begin
  fmAddTrans.Init(CurrencyDetail);
  fmAddTrans.ShowModal;
end;

procedure TfmMain.bbAddOrigChequeClick(Sender: TObject);
begin
  if (OrigChequesAccID = 0) or (RecChequesAccID = 0) then
    MessageDlg('لابد من تحديد حساب الشيكات تحت التحصيل، والشيكات الصادرة في إعدادات الوحدة المحاسبية',
      mtWarning, [mbOk], 0)
  else
  begin
    fmInsertCheque.Init(ctOriginated, Currency);
    fmInsertCheque.ShowModal;
  end;
end;

procedure TfmMain.bbBackupClick(Sender: TObject);
begin
  with dmData.IBConnection1 do
  fmBackupDatabase.Init(DatabaseName, UserName, Password);
  fmBackupDatabase.ShowModal;
end;

procedure TfmMain.bbChartClick(Sender: TObject);
var
  Accounts: string;
  Total: Double;
  ResultStr: string;
  Col: Integer;
  ColStr: string;
  ColValue: Double;
begin
  fmDateDialog.Init(True);
  if fmDateDialog.ShowModal = mrOK then
  with dmData.sqGeneral do
  begin
    Accounts:= IntToStr(fmDateDialog.SelectedAccountID) + ',' + dmData.GetAllChildAccounts(fmDateDialog.SelectedAccountID);
    if (Accounts <> '') and (Accounts[Length(Accounts)] = ',') then
      System.Delete(Accounts, Length(Accounts), 1);

    Close;
    SQL.Text:= 'select Sum(Debit - Credit) as Total, AccountName ' +
     'from Trans ' +
     'inner join Accounts on Accounts.AccountID = Trans.AccountID ' +
     'where Trans.AccountID in (' + Accounts + ') and TransType = 1 ' +
     'and TransTime > :FromDate and TransTime <= :ToDate ' +
     'group by AccountName ' +
     'order by Total';
    Params.ParamByName('FromDate').Value:= fmDateDialog.deFromDate.Date;
    Params.ParamByName('ToDate').Value:= fmDateDialog.deToDate.Date + 1;
    Open;
    fmChartReport.BarChart1.Clear;
    fmChartReport.BarChart1.Caption:= fmDateDialog.cbAccount.Text + ' من ' +
      DateToStr(fmDateDialog.deFromDate.Date) + ' إلى '  +
      DateToStr(fmDateDialog.deToDate.Date);

    Total:= 0;
    while not Eof do
    begin
      ColValue:= FieldByName('Total').AsFloat;;
      Total:= Total + ColValue;

      if ColValue > 0 then
      begin
        Col:= clGreen;
        ColStr:= 'مدين';
      end
      else
      if ColValue < 0 then
      begin
        Col:= clRed;
        ColStr:= 'دائن';
      end
      else
        ColStr:= '';

      fmChartReport.BarChart1.AddBar(FieldByName('AccountName').AsString + '-' + ColStr,
        Round(Abs(FieldByName('Total').AsFloat)), Col);
      Next;
    end;
    if Total < 0 then
      ResultStr:= 'دائن'
    else
    if Total > 0 then
      ResultStr:= 'مدين'
    else
      ResultStr:= '';

    fmChartReport.BarChart1.Caption:= fmChartReport.BarChart1.Caption + ', المجموع ' + Format('%3.0n', [Abs(Total)]) +  ' ' +
      Currency + ' ' + ResultStr;
    Close;
    fmChartReport.ShowModal;

  end;

end;

procedure TfmMain.bbChequeHistoryReportClick(Sender: TObject);
var
  ChequeID: Integer;
  BankID, DebitAccID, CreditAccID, Direction, StateID: Integer;
  ChequeNo, AccountNo, Details, Res: string;
  ChequeValue: Double;
  EntryDate, ChequeDate: TDateTime;
begin
  if dmData.sqOrigCheques.Active and (dmData.sqOrigCheques.RecordCount > 0) then
  with dmData.sqChequeTransHistory do
  begin
    fmChequeHistoryReport:= TfmChequeHistoryReport.Create(nil);
    ChequeID:= dmData.sqOrigCheques.FieldByName('ChequeID').AsInteger;
    dmData.GetChequeInfo(ChequeID, BankID, CreditAccID, DebitAccID, Direction, StateID, ChequeNo, AccountNo, Details, ChequeValue,
      EntryDate, ChequeDate, Res);
    Close;
    Params.ParamByName('ChequeID').AsInteger:= ChequeID;
    Open;
    fmChequeHistoryReport.laDetails.Caption:= Details;
    fmChequeHistoryReport.laValue.Caption:= Format('%3.0n %s', [ChequeValue, Currency]);
    dmData.sqBanks.Open;
    if dmData.sqBanks.Locate('BankID', BankID, []) then
      fmChequeHistoryReport.laBank.Caption:= dmData.sqBanks.FieldByName('BankName').AsString
    else
      fmChequeHistoryReport.laBank.Caption:= '';
    fmChequeHistoryReport.laAccount.Caption:= AccountNo + ', ' + ChequeNo;
    fmChequeHistoryReport.laChequeID.Caption:= IntToStr(ChequeID);
    dmData.sqAccounts.Open;
    if dmData.sqAccounts.Locate('AccountID', DebitAccID, []) then
      fmChequeHistoryReport.laDebit.Caption:= dmData.sqAccounts.FieldByName('AccountName').AsString;

    if dmData.sqAccounts.Locate('AccountID', CreditAccID, []) then
      fmChequeHistoryReport.laCredit.Caption:= dmData.sqAccounts.FieldByName('AccountName').AsString;
    dmData.sqAccounts.Close;

    fmChequeHistoryReport.RLReport1.PreviewModal;
    Close;
  end;

end;

procedure TfmMain.bbChequesReportClick(Sender: TObject);
var
  Total: Double;
begin
  fmChequesReport.lrDate.Caption:= DateToStr(Date);
  fmChequesReport.rlTitle.Caption:= cbChequeTypes.Text;
  fmChequesReport.laState.Caption:= cbChequeState.Text;
  Total:= 0;
  DBGrid1.Visible:= False;
  dmData.sqOrigCheques.First;
  with dmData.sqOrigCheques do
  while not Eof do
  begin
    Total:= Total + FieldByName('ChequeValue').AsFloat;
    Next;
  end;
  dmData.sqOrigCheques.First;
  DBGrid1.Visible:= True;
  fmChequesReport.laTotal.Caption:= Format('%3.0n %s', [Total, Currency]);
  fmChequesReport.RLReport1.PreviewModal;
end;

procedure TfmMain.bbEditBanksClick(Sender: TObject);
begin
  fmEditBanks.Init;
  fmEditBanks.Show;
end;

procedure TfmMain.bbGetChequesClick(Sender: TObject);
var
  ChequeState: Integer;
begin
  if tsCheques.Showing then
  with dmData.sqOrigCheques do
  begin
    Close;
    SQL.Text:= 'select ChequeID, ChequeNo, AccountNo, AC.AccountName as CreditAccount, AD.AccountName as DebitAccount, ' +
      'BankName, EntryDate, ChequeDate, ChequeValue,' +
      'StateName, Details, UserName, CreditAccID, DebitAccID from Cheques ' +
      'inner join Banks on Cheques.BankID = Banks.BankID ' +
      'inner join Accounts AC on Cheques.CreditAccID = AC.AccountID ' +
      'inner join Accounts AD on Cheques.DebitAccID = AD.AccountID ' +
      'inner join ChequeStates on Cheques.StateID = ChequeStates.StateID where ';

    ChequeState:= cbChequeState.ItemIndex + 1;
    SQL.Add('Cheques.StateID = ' + IntToStr(ChequeState));
    SQL.Add('and Direction = ' + IntToStr(cbChequeTypes.ItemIndex + 1));

    if cxOrigBanks.Checked and (cbBanks.ItemIndex <> -1) then
      SQL.Add('and Cheques.BankID = '  + IntToStr(BankIDs[cbBanks.ItemIndex]));

    if cxChequeDate.Checked then
    begin
      if ChequeState = 1 then
        SQL.Add('and ChequeDate <= :ChequeDate')
      else
        SQL.Add('and ChequeDate >= :ChequeDate')
    end;
    SQL.Add('order by ChequeDate');
    if cxChequeDate.Checked then
      Params.ParamByName('ChequeDate').AsDate:= Trunc(deOrigChequeDate.Date);
    Open;
  end;
end;

procedure TfmMain.bbPayChequeClick(Sender: TObject);
begin
  if cbChequeTypes.ItemIndex = 0 then
    fmModifyCheque.laAccountTitle.Caption:= 'الحساب الدائن'
  else
    fmModifyCheque.laAccountTitle.Caption:= 'الحساب المدين';

  with dmData.sqOrigCheques do
  if Active and (RecordCount > 0) then
  if cbChequeState.ItemIndex <> 0 then
    ShowMessage('هذا الشيك لايمكن صرفه')
  else
  if FieldByName('ChequeDate').AsDateTime > Date then
    ShowMessage('هذا الشيك لايمكن صرفه، حيث أن وقت الصرف لم يحن بعد')
  else
  begin
    fmModifyCheque.Init(FieldByName('ChequeID').AsInteger, 2, FieldByName('CreditAccID').AsInteger,
      FieldByName('DebitAccID').AsInteger, FieldByName('ChequeValue').AsFloat, 'صرف شيك', FieldByName('ChequeNo').AsString,
      FieldByName('AccountNo').AsString, FieldByName('BankName').AsString, FieldByName('Details').AsString, clGreen);
    fmModifyCheque.ShowModal;
  end;
end;

procedure TfmMain.bbChequeRDClick(Sender: TObject);
begin
  with dmData.sqOrigCheques do
  if Active and (RecordCount > 0) then
  if cbChequeState.ItemIndex <> 0 then
    ShowMessage('هذا الشيك لايمكن تحويله إلى شيك مرتد')
  else
  if FieldByName('ChequeDate').AsDateTime > Date then
    ShowMessage('هذا الشيك لايمكن تحويله إلى شيك مرتد، حيث أن وقت الصرف لم يحن بعد')
  else
  begin
    fmModifyCheque.Init(FieldByName('ChequeID').AsInteger, 3, FieldByName('CreditAccID').AsInteger,
      FieldByName('DebitAccID').AsInteger, FieldByName('ChequeValue').AsFloat, 'إرتداد شيك', FieldByName('ChequeNo').AsString,
      FieldByName('AccountNo').AsString, FieldByName('BankName').AsString, FieldByName('Details').AsString, clRed);
    fmModifyCheque.ShowModal;
  end;

end;

procedure TfmMain.bbWithdrawChequeClick(Sender: TObject);
begin
  with dmData.sqOrigCheques do
  if Active and (RecordCount > 0) then
    if cbChequeState.ItemIndex <> 0 then
    ShowMessage('هذا الشيك لايمكن سحبه')
  else
  begin
    fmModifyCheque.Init(FieldByName('ChequeID').AsInteger, 4, FieldByName('CreditAccID').AsInteger,
      FieldByName('DebitAccID').AsInteger, FieldByName('ChequeValue').AsFloat, 'سحب شيك', FieldByName('ChequeNo').AsString,
      FieldByName('AccountNo').AsString, FieldByName('BankName').AsString, FieldByName('Details').AsString, clGray);
    fmModifyCheque.ShowModal;
  end;

end;

procedure TfmMain.bbDelayChequeClick(Sender: TObject);
begin
  with dmData.sqOrigCheques do
  if cbChequeState.ItemIndex <> 0 then
    ShowMessage('هذا الشيك لايمكن تأجيله، فقط يمكن تأجيل الشيك في وضع اﻹنتظار')
  else
  if Active and (RecordCount > 0) then
  begin
    fmModifyCheque.Init(FieldByName('ChequeID').AsInteger, 10, FieldByName('CreditAccID').AsInteger,
      FieldByName('DebitAccID').AsInteger, FieldByName('ChequeValue').AsFloat, 'تأجيل شيك', FieldByName('ChequeNo').AsString,
      FieldByName('AccountNo').AsString, FieldByName('BankName').AsString, FieldByName('Details').AsString, clGray);
    fmModifyCheque.ShowModal;
  end;

end;

procedure TfmMain.bbGetOrigCheques5Click(Sender: TObject);
begin

end;

procedure TfmMain.bbReportsManageClick(Sender: TObject);
begin
  fmEditReports.Init;
  fmEditReports.ShowModal;
  CreateReportButtons;
end;

procedure TfmMain.bbUsersManageClick(Sender: TObject);
begin
  fmUsers.Init;
  fmUsers.Show;
end;

procedure TfmMain.bbAddNewUserClick(Sender: TObject);
begin
  fmAddUser.ShowModal;
end;

procedure TfmMain.bbArchiveClick(Sender: TObject);
var
  AMessage: string;
  Year, Month, Day: Word;
begin
  if bbArchive.Visible then
  begin
    DecodeDate(Date, Year, Month, Day);
    AMessage:= 'سوف يتم تجميع معاملات العام الماضي ' + IntToStr(Year - 1)  + ' ' +
     'و وضع مجموعها في معاملة ترحيل بتاريخ اليوم، وسوف يتم حذف جميع ' +
     ' تفاصيل معاملات العام الماضي' + '  بمافيها الشيكات' + #10 +
     'هذه العملية لايمكن إسترجاعها، لذلك ننصح بعمل نسخة إحتياطية لقاعدة بيانات العام الماضي لإستخدامها للتفاصيل' + #10 +
     'هل تريد اﻹستمرار في هذه العملية';
    if MessageDlg('ترحيل البيانات', AMessage, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      if dmData.DoArchiving then
        ShowMessage('تم ترحيل حسابات العام الماضي بنجاح');
      bbArchive.Visible:= dmData.ArchivingIsNeeded;
    end;

  end;
end;

procedure TfmMain.bbChangePassClick(Sender: TObject);
begin
  fmChangePass.Init(dmData.IBConnection1.UserName, True);
  fmChangePass.ShowModal;
end;

procedure TfmMain.bbDailyReportClick(Sender: TObject);
var
  Accounts: string;
  SelectedAccount: Integer;
  PreIndex: Integer;
  Line: string;
  F: TextFile;
  i: Integer;
  Net: Double;
  ReportTitle: string;
  ReportFromDateStr: string;
  ReportToDateStr: string;
  ReportAccountName: string;
  CreditTotal, DebitTotal: Double;
begin
  // Refresh data
  dmData.SQLTransaction1.Commit;

  PreIndex:= fmSelDate.cbAccount.ItemIndex;
  ReportTitle:= 'تقرير اليومية: ' +  EntityName;
  dmData.FillAccountsBox(fmSelDate.cbAccount.Items, fmSelDate.AccountIDs);
  fmSelDate.cbAccount.Items.Insert(0, 'كل الحسابات');
  if (PreIndex <> -1) and (PreIndex < fmSelDate.cbAccount.Items.Count) then
    fmSelDate.cbAccount.ItemIndex:= PreIndex
  else
    fmSelDate.cbAccount.ItemIndex:= 0;

  if fmSelDate.ShowModal = mrOK then
  with dmData.sqDailyReport do
  begin
    Close;
    ReportAccountName:= fmSelDate.cbAccount.Text;
    Sql.Text:= 'select TransID, TransTime, AccountName, Credit, Debit, EntryID, Details, UserName ' +
      ' from Trans ' +
      'inner join accounts on Accounts.AccountID = Trans.AccountID ' +
      'where ';

    if fmSelDate.cbAccount.ItemIndex <> 0 then // Specific Account
    begin
      SelectedAccount:= fmSelDate.AccountIDs[fmSelDate.cbAccount.ItemIndex - 1];
      Accounts:= IntToStr(SelectedAccount) + ',' + dmData.GetAllChildAccounts(SelectedAccount);
      System.Delete(Accounts, Length(Accounts), 1);
      SQL.Add('Trans.AccountID in (' + Accounts + ') and');
    end;

    // TransType for Archive
    if not fmSelDate.cxIncludeArchived.Checked then
      sql.Add('TransType = 1 and');

    // Date
    if fmSelDate.cxDate.Checked then
      SQL.Add('TransTime >= :FromDate and TransTime < :ToDate and');

    // Details text search
    if (fmSelDate.edSearch.Text) <> '' then
      SQL.Add('Details like ''%' + fmSelDate.edSearch.Text + '%'' and');

    SQL.Add('1=1');
    Sql.Add('order by EntryID, Credit');

    if fmSelDate.cxDate.Checked then
    begin
      Params.ParamByName('FromDate').AsDate:= fmSelDate.deFromDate.Date;
      Params.ParamByName('ToDate').AsDate:= fmSelDate.deToDate.Date + 1;
      ReportFromDateStr:= DateToStr(fmSelDate.deFromDate.Date);
      ReportToDateStr:= DateToStr(fmSelDate.deToDate.Date);
    end
    else
    begin
      ReportFromDateStr:= '-';
      ReportToDateStr:= '-';
    end;

    Open;
    CreditTotal:= 0;
    DebitTotal:= 0;
    while not Eof do
    begin
      CreditTotal:= CreditTotal + FieldByName('Credit').AsFloat;
      DebitTotal:= DebitTotal + FieldByName('Debit').AsFloat;
      Next;
    end;
    First;

    // Report type
    if fmSelDate.cbType.ItemIndex = 0 then  // Show Report
    with fmGeneralReport do
    begin
      if fmSelDate.cxIncludeDetails.Checked then
      begin
        Datasource1.DataSet:= dmData.sqDailyReport;
        RLBand2.Show;
      end
      else
      begin
        Datasource1.DataSet:= nil;
        RLBand2.Hide;
      end;
      rlTitle.Caption:= ReportTitle;
      if Frac(DebitTotal) = 0 then
        laDebitTotal.Caption:= Format('%3.0n', [DebitTotal])
      else
        laDebitTotal.Caption:= Format('%3.2n', [DebitTotal]);

      if Frac(CreditTotal) = 0 then
        laCreditTotal.Caption:= Format('%3.0n', [CreditTotal])
      else
        laCreditTotal.Caption:= Format('%3.2n', [CreditTotal]);

      Net:= DebitTotal - CreditTotal;
      if Net = 0 then
        laNet.Caption:= '0'
      else
      if Net > 0 then
      begin
        if Frac(Net) = 0 then
          laNet.Caption:= Format('%3.0n   %s  %s', [Abs(Net), Currency, 'مدين'])
        else
          laNet.Caption:= Format('%3.2n   %s  %s', [Abs(Net), Currency, 'مدين']);

        laNet.Font.Color:= clGreen;
      end
      else
      begin
        if Frac(Net) = 0 then
          laNet.Caption:= Format('(%3.0n)   %s  %s', [Abs(Net), Currency, 'دائن'])
        else
          laNet.Caption:= Format('(%3.2n)   %s  %s', [Abs(Net), Currency, 'دائن']);
        laNet.Font.Color:= clRed;
      end;
      laFrom.Caption:= ReportFromDateStr;
      laTo.Caption:= ReportToDateStr;
      laAccount.Caption:= ReportAccountName;
      RLReport1.PreviewModal;
    end
    else // CSV file
    begin
      AssignFile(F, fmSelDate.SaveDialog1.FileName);
      Rewrite(F);
      Writeln(F, ReportTitle);
      Writeln(F, 'من التاريخ ', ReportFromDateStr, ', ' + ReportToDateStr);
      Writeln(F, 'إلى التاريخ ', ReportAccountName);

      Line:= '';
      for i:= 0 to FieldCount - 1 do
        Line:= Line + Fields[i].FieldName + ',';
      Writeln(F, Line);

      while not Eof do
      begin
        Line:= '';
        for i:= 0 to FieldCount - 1 do
          Line:= Line + '"' + Fields[i].AsString + '",';
        Writeln(F, Line);
        Next;
      end;

      Writeln(F, ',,,', FloatToStr(CreditTotal), ',', FloatToStr(DebitTotal));

      Net:= CreditTotal - DebitTotal;
      if Net = 0 then
        Line:= '0'
      else
      if Net > 0 then
        Line:= Format('%3.0n   %s  %s', [Abs(Net), Currency, 'مدين'])
      else
        Line:= Format('(%3.0n)   %s  %s', [Abs(Net), Currency, 'دائن']);
      Writeln(F, 'المجموع ', Line);
      CloseFile(F);

    end;

    Close;
  end;
end;

procedure TfmMain.bbDailyReportMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  (Sender as TBitBtn).Color:= clWhite;
end;

procedure TfmMain.bbDailyReportMouseLeave(Sender: TObject);
var
  BitButton: TBitBtn;
begin
  BitButton:= Sender as TBitBtn;
  if BitButton.Tag <= 0 then
    BitButton.Color:= $00D8D8D8
  else
  if BitButton.Tag > 0 then
    BitButton.Color:= $00DCDFD5;
end;

procedure TfmMain.bbDailyReportMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  BitButton: TBitBtn;
begin
  BitButton:= Sender as TBitBtn;

  if BitButton.Tag = 0 then
    BitButton.Color:= RGBToColor(200, 250, 200)
  else
  if BitButton.Tag = -1 then
    BitButton.Color:= RGBToColor(250, 200, 200)
  else
    BitButton.Color:= RGBToColor(250, 250, 200);

end;

procedure TfmMain.bbEditAccountsClick(Sender: TObject);
begin
  fmEditAccounts.Init;
  fmEditAccounts.ShowModal;
end;

procedure TfmMain.bbEditEntryFormsClick(Sender: TObject);
begin
  fmEditEntryForms.Init;
  fmEditEntryForms.ShowModal;
  CreateEntryButtons;
end;

procedure TfmMain.bbEditIdentityClick(Sender: TObject);
begin
  fmConfig.Init;
  if fmConfig.ShowModal = mrOK then
    Init;
end;

procedure TfmMain.cbBanksChange(Sender: TObject);
begin
  if cxOrigBanks.Checked then
    bbGetChequesClick(nil);
end;

procedure TfmMain.cbChequeTypesChange(Sender: TObject);
begin
  bbGetChequesClick(nil);
end;

procedure TfmMain.cxOrigBanksClick(Sender: TObject);
begin
  if not cxOrigBanks.Checked then
    cbBanks.ItemIndex:= -1;
  bbGetChequesClick(nil);
end;

procedure TfmMain.cxChequeDateChange(Sender: TObject);
begin
  bbGetChequesClick(nil);
end;

procedure TfmMain.DBGrid1DblClick(Sender: TObject);
begin
  bbChequeHistoryReportClick(nil);
end;

procedure TfmMain.deOrigChequeDateChange(Sender: TObject);
begin
  if cxChequeDate.Checked then
    bbGetChequesClick(nil);
end;

procedure TfmMain.bbAddAccountClick(Sender: TObject);
begin
  fmAddAccount.Init(-1);
  fmAddAccount.Show;
end;

procedure TfmMain.bbAccountsTreeClick(Sender: TObject);
begin
  fmAccountsTree.Init(-1, False);
  fmAccountsTree.Show;
end;

procedure TfmMain.bbAccountsReportClick(Sender: TObject);
var
  PreIndex: Integer;
  Accounts: string;
  SelectedAccount: Integer;
begin
  PreIndex:= fmSelAccounts.cbAccount.ItemIndex;
  dmData.FillAccountsBox(fmSelAccounts.cbAccount.Items, fmSelAccounts.AccountIDs);
  fmSelAccounts.cbAccount.Items.Insert(0, 'الحسابات اﻷساسية');
  if (PreIndex <> -1) and (PreIndex < fmSelAccounts.cbAccount.Items.Count) then
    fmSelAccounts.cbAccount.ItemIndex:= PreIndex
  else
    fmSelAccounts.cbAccount.ItemIndex:= 0;

  if fmSelAccounts.ShowModal = mrOK then
  with dmData.sqAccountsReport do
  begin
    Close;
    if fmSelAccounts.cbAccount.ItemIndex = 0 then
    begin
      SQL.Text:= 'select * from Accounts where ParentAccountID = 0 order by AccountID';
      fmAccountsReport.laAccountTitle.Caption:= EntityName + ': الحسابات اﻷساسية';
    end
    else
    begin
      SelectedAccount:= fmSelAccounts.AccountIDs[fmSelAccounts.cbAccount.ItemIndex - 1];
      Accounts:= IntToStr(SelectedAccount) + ',' + dmData.GetAllChildAccounts(SelectedAccount);
      System.Delete(Accounts, Length(Accounts), 1);
      SQL.Text:= 'select * from Accounts where AccountID in (' + Accounts + ') order by AccountID';
      fmAccountsReport.laAccountTitle.Caption:= EntityName + ' : ' + fmSelAccounts.cbAccount.Text;
    end;
    Open;

    fmAccountsReport.RLReport1.PreviewModal;
    Close;
  end;
end;

procedure TfmMain.FormCreate(Sender: TObject);
var
  Year, Month, Day: Word;
  MonthStr: string;
begin
  ShortMonthNames[1]:= 'يناير';
  ShortMonthNames[2]:= 'فبراير';
  ShortMonthNames[3]:= 'مارس';
  ShortMonthNames[4]:= 'أبريل';
  ShortMonthNames[5]:= 'مايو';
  ShortMonthNames[6]:= 'يونيو';
  ShortMonthNames[7]:= 'يوليو';
  ShortMonthNames[8]:= 'أغسطس';
  ShortMonthNames[9]:= 'سبتمبر';
  ShortMonthNames[10]:= 'أكتوبر';
  ShortMonthNames[11]:= 'نوفمبر';
  ShortMonthNames[12]:= 'ديسمبر';

  ShortDayNames[1]:= 'اﻷحد';
  ShortDayNames[2]:= 'اﻹثنين';
  ShortDayNames[3]:= 'الثلاثاء';
  ShortDayNames[4]:= 'اﻷربعاء';
  ShortDayNames[5]:= 'الخميس';
  ShortDayNames[6]:= 'الجمعة';
  ShortDayNames[7]:= 'السبت';

  ShortDateFormat:= 'dd/mm/yyyy';

  DateToHejri(Now, Year, Month, Day);

  laDate.Caption:= FormatDateTime('d mmm yyy', Now);

  MonthStr:= HejriUtils.HejriMonthsAr[Month];

  laHejri.Caption:= Format('%d %s %d', [Day, MonthStr, Year]);

  laWeekDay.Caption:= FormatDateTime('ddd', Now);

  Activated:= False;
end;

procedure TfmMain.FormResize(Sender: TObject);
begin
  ReOrganizeButtons;
  ReOrganizeReportButtons;
end;

procedure TfmMain.frDBDataSet2CheckEOF(Sender: TObject; var Eof: Boolean);
begin

end;


procedure TfmMain.laURLClick(Sender: TObject);
begin
  OpenURL(laURL.Caption);
end;

procedure TfmMain.tsChequesEnter(Sender: TObject);
begin
  bbGetChequesClick(nil);
end;

procedure TfmMain.tsChequesExit(Sender: TObject);
begin
  dmData.sqOrigCheques.Close;
end;

procedure TfmMain.tsEntryResize(Sender: TObject);
begin
  ReOrganizeButtons;
end;

procedure TfmMain.tsReportsEnter(Sender: TObject);
begin
  ReOrganizeReportButtons;
end;

procedure TfmMain.tsReportsResize(Sender: TObject);
begin
  ReOrganizeReportButtons;
end;

procedure TfmMain.CreateEntryButtons;
var
  i, x, y: Integer;
  EntryButton: TBitBtn;
begin
  ReleaseEntryButtons;
  dmData.sqGeneral.Close;
  dmData.sqGeneral.SQL.Text:= 'select FormID, Title from EntryForms order by FormID';
  dmData.sqGeneral.Open;
  i:= 0;
  x:= 0;
  y:= 20;
  SetLength(EntryButtonsArray, 0);
  with dmData.sqGeneral do
  while not Eof do
  begin
    Inc(i);
    EntryButton:= TBitBtn.Create(nil);
    EntryButton.Parent:= tsEntry;
    EntryButton.Anchors:= [akTop, akRight];
    EntryButton.Width:= 120;
    EntryButton.Height:= 40;
    Inc(x);
    if (x * 150) + 20 > tsEntry.Width then
    begin
      x:= 1;
      Inc(y, 50);
    end;

    EntryButton.Top:= y;
    EntryButton.Left:= tsEntry.Width - 10 - (x * 150);
    EntryButton.Tag:= FieldByName('FormID').AsInteger;
    EntryButton.Caption:= FieldByName('Title').AsString;
    EntryButton.OnClick:= @EntryFormClick;
    EntryButton.Color:= $00DCDFD5;
    EntryButton.OnMouseDown:= bbDailyReport.OnMouseDown;
    EntryButton.OnMouseMove:= bbDailyReport.OnMouseMove;
    EntryButton.OnMouseLeave:= bbDailyReport.OnMouseLeave;
    SetLength(EntryButtonsArray, i);
    EntryButtonsArray[i - 1]:= EntryButton;
    Next;
  end;
  dmData.sqGeneral.Close;
end;

procedure TfmMain.CreateReportButtons;
var
  i, x, y: Integer;
  ReportButton: TBitBtn;
begin
  ReleaseReportButtons;
  dmData.sqGeneral.Close;
  dmData.sqGeneral.SQL.Text:= 'select ReportID, Title from Reports order by ReportID';
  dmData.sqGeneral.Open;
  i:= 0;
  x:= 0;
  y:= 20;
  SetLength(ReportButtonsArray, 0);
  with dmData.sqGeneral do
  while not Eof do
  begin
    Inc(i);
    ReportButton:= TBitBtn.Create(nil);
    ReportButton.Parent:= tsReports;
    ReportButton.Anchors:= [akTop, akRight];
    ReportButton.Width:= 180;
    ReportButton.Height:= 40;
    Inc(x);
    if (x * 180) + 10 > tsReports.Width then
    begin
      x:= 1;
      Inc(y, 50);
    end;

    ReportButton.Top:= y;
    ReportButton.Left:= tsReports.Width - 10 - (x * 180);
    ReportButton.Tag:= FieldByName('ReportID').AsInteger;
    ReportButton.Caption:= FieldByName('Title').AsString;
    ReportButton.OnClick:= @ReportClick;
    ReportButton.Color:= $00DCDFD5;
    ReportButton.OnMouseDown:= bbDailyReport.OnMouseDown;
    ReportButton.OnMouseMove:= bbDailyReport.OnMouseMove;
    ReportButton.OnMouseLeave:= bbDailyReport.OnMouseLeave;
    SetLength(ReportButtonsArray, i);
    ReportButtonsArray[i - 1]:= ReportButton;
    Next;
  end;
  dmData.sqGeneral.Close;
end;

procedure TfmMain.EntryFormClick(Sender: TObject);
var
  FormID: Integer;
  Filter: string;
  Title: string;
  CreditAccountID: Integer;
  DebitAccountID: Integer;
  DefaultDetail: string;
  i: Integer;
begin
  FormID:= (Sender as TBitBtn).Tag;
  if dmData.GetEntryFormInfo(FormID, Title, DefaultDetail, CreditAccountID, DebitAccountID) then
  begin
    // Credit Account
    Filter:= dmData.GetAllChildAccounts(CreditAccountID);
    Filter:= IntToStr(CreditAccountID) + ',' + Filter;
    dmData.FillAccountsBox(fmEntryForm.cbCreditAccount.Items, fmEntryForm.CreditAccounts, Filter);
    for i:= 0 to High(fmEntryForm.CreditAccounts) do
      if CreditAccountID = fmEntryForm.CreditAccounts[i] then
      begin
         fmEntryForm.cbCreditAccount.ItemIndex:= i;
         Break;
      end;

    // Debit Account
    Filter:= dmData.GetAllChildAccounts(DebitAccountID);
    Filter:= IntToStr(DebitAccountID) + ',' + Filter;
    dmData.FillAccountsBox(fmEntryForm.cbDebitAccount.Items, fmEntryForm.DebitAccounts, Filter);
    for i:= 0 to High(fmEntryForm.DebitAccounts) do
      if DebitAccountID = fmEntryForm.DebitAccounts[i] then
      begin
         fmEntryForm.cbDebitAccount.ItemIndex:= i;
         Break;
      end;

    fmEntryForm.Caption:= Title;
    fmEntryForm.edDetails.Text:= DefaultDetail;
    fmEntryForm.Init(CreditAccountID, DebitAccountID, CurrencyDetail);
    fmEntryForm.ShowModal;
  end;
end;

procedure TfmMain.ReportClick(Sender: TObject);
var
  ReportID: Integer;
  Title, SearchText, Accounts: string;
  IncludeDetails, IncludeDate, IncludeArchive: Boolean;
  Net: Double;
  ReportTitle: string;
  ReportFromDateStr: string;
  ReportToDateStr: string;
  ReportAccountName: string;
  CreditTotal, DebitTotal: Double;
begin
  ReportID:= (Sender as TBitBtn).Tag;
  if dmData.GetReportInfo(ReportID, Title, SearchText, IncludeDetails, IncludeDate, IncludeArchive, Accounts) then
  begin
    ReportTitle:= EntityName + ': ' + Title;
    fmDateDialog.Init(False);
    if (not IncludeDate) or (fmDateDialog.ShowModal = mrOK) then
    with dmData.sqDailyReport do
    begin
      ReportAccountName:= '';
      Close;
      Sql.Text:= 'select TransID, TransTime, AccountName, Credit, Debit, EntryID, Details, UserName ' +
        ' from Trans ' +
        'inner join accounts on Accounts.AccountID = Trans.AccountID ' +
        'where ';

      SQL.Add('Trans.AccountID in (' + Accounts + ') and');

      // TransType for Archive
      if not IncludeArchive then
        sql.Add('TransType = 1 and');

      // Date
      if IncludeDate then
        SQL.Add('TransTime >= :FromDate and TransTime < :ToDate and');

      // Details text search
      if (SearchText) <> '' then
        SQL.Add('Details like ''%' + SearchText + '%'' and');

      SQL.Add('1=1');
      Sql.Add('order by EntryID, Credit');

      if IncludeDate then
      begin
        Params.ParamByName('FromDate').AsDate:= fmDateDialog.deFromDate.Date;
        Params.ParamByName('ToDate').AsDate:= fmDateDialog.deToDate.Date + 1;
        ReportFromDateStr:= DateToStr(fmDateDialog.deFromDate.Date);
        ReportToDateStr:= DateToStr(fmDateDialog.deToDate.Date);
      end
      else
      begin
        ReportFromDateStr:= '-';
        ReportToDateStr:= '-';
      end;

      Open;
      CreditTotal:= 0;
      DebitTotal:= 0;
      while not Eof do
      begin
        CreditTotal:= CreditTotal + FieldByName('Credit').AsFloat;
        DebitTotal:= DebitTotal + FieldByName('Debit').AsFloat;
        Next;
      end;
      First;

      // Show report
      with fmGeneralReport do
      begin
        if IncludeDetails then
        begin
          Datasource1.DataSet:= dmData.sqDailyReport;
          RLBand2.Show;
        end
        else
        begin
          Datasource1.DataSet:= nil;
          RLBand2.Hide;
        end;

        rlTitle.Caption:= ReportTitle;
        laAccountTitle.Caption:= '';
        if Frac(DebitTotal) = 0 then
          laDebitTotal.Caption:= Format('%3.0n', [DebitTotal])
        else
          laDebitTotal.Caption:= Format('%3.2n', [DebitTotal]);

        if Frac(CreditTotal) = 0 then
          laCreditTotal.Caption:= Format('%3.0n', [CreditTotal])
        else
          laCreditTotal.Caption:= Format('%3.2n', [CreditTotal]);

        Net:= DebitTotal - CreditTotal;
        if Net = 0 then
          laNet.Caption:= '0'
        else
        if Net > 0 then
        begin
          if Frac(Net) = 0 then
            laNet.Caption:= Format('%3.0n   %s  %s', [Abs(Net), Currency, 'مدين'])
          else
            laNet.Caption:= Format('%3.2n   %s  %s', [Abs(Net), Currency, 'مدين']);
          laNet.Font.Color:= clGreen;
        end
        else
        begin
          if Frac(Net) = 0 then
            laNet.Caption:= Format('(%3.0n)   %s  %s', [Abs(Net), Currency, 'دائن'])
          else
            laNet.Caption:= Format('(%3.2n)   %s  %s', [Abs(Net), Currency, 'دائن']);
          laNet.Font.Color:= clRed;
        end;
        laFrom.Caption:= ReportFromDateStr;
        laTo.Caption:= ReportToDateStr;
        laAccount.Caption:= ReportAccountName;
        RLReport1.PreviewModal;

      end;
      Close;
    end;
  end;
end;

procedure TfmMain.ReleaseEntryButtons;
var
  i: Integer;
begin
  for i:= 0 to High(EntryButtonsArray) do
    EntryButtonsArray[i].Free;
  SetLength(EntryButtonsArray, 0);
end;

procedure TfmMain.ReleaseReportButtons;
var
  i: Integer;
begin
  for i:= 0 to High(ReportButtonsArray) do
    ReportButtonsArray[i].Free;
  SetLength(ReportButtonsArray, 0);
end;

procedure TfmMain.ReOrganizeButtons;
var
  i: Integer;
  x, y: Integer;
begin
  x:= 0;
  y:= 20;
  for i:= 0 to High(EntryButtonsArray) do
  begin
    Inc(x);
    if (x * 150) + 20 > tsEntry.Width then
    begin
      x:= 1;
      Inc(y, 50);
    end;

    EntryButtonsArray[i].Top:= y;
    EntryButtonsArray[i].Left:= tsEntry.Width - 10 - (x * 150);

  end;
end;

procedure TfmMain.ReOrganizeReportButtons;
var
  i: Integer;
  x, y: Integer;
begin
  x:= 0;
  y:= 20;
  for i:= 0 to High(ReportButtonsArray) do
  begin
    Inc(x);
    if (x * 180) + 20 > tsReports.Width then
    begin
      x:= 1;
      Inc(y, 50);
    end;

    ReportButtonsArray[i].Top:= y;
    ReportButtonsArray[i].Left:= tsReports.Width - 10 - (x * 180);

  end;
end;

procedure TfmMain.Init;
var
  Admin: Boolean;
begin
  Admin:= (dmData.IBConnection1.Role = '') or (LowerCase(dmData.IBConnection1.Role) = 'adminrole');
  PageControl1.ActivePageIndex:= 0;
  PageControl2.ActivePageIndex:= 0;

  deOrigChequeDate.Date:= Date;

  dmData.sqGeneral.Close;
  dmData.sqGeneral.SQL.Text:= 'select * from Config';
  dmData.sqGeneral.Open;
  with dmData.sqGeneral do
  if RecordCount > 0 then
  begin
    EntityName:= FieldByName('Title').AsString;
    Caption:= 'نظام الحسابات الشخصية: ' +  EntityName;
    stEntity.Caption:= EntityName;
    Application.Title:= Caption;
    EntityEnabled:= FieldByName('Enabled').AsBoolean;
    stEntityDetails.Caption:= FieldByName('Description').AsString;
    Currency:= FieldByName('Unit').AsString;
    CurrencyDetail:= FieldByName('UnitName').AsString;
    OrigChequesAccID:= FieldByName('OrigChequesAccID').AsInteger;
    RecChequesAccID:= FieldByName('RecChequesAccID').AsInteger;
  end;
  dmData.sqGeneral.Close;

  bbAddAccount.Visible:= Admin and EntityEnabled;
  bbAddAccount.Enabled:= bbAddAccount.Visible;

  bbEditAccounts.Visible:= Admin and EntityEnabled;
  bbEditAccounts.Enabled:= bbEditAccounts.Visible;

  bbEditEntryForms.Visible:= Admin and EntityEnabled;
  bbEditEntryForms.Enabled:= bbEditEntryForms.Visible;

  bbAddNewUser.Visible:= Admin;
  bbAddNewUser.Enabled:= bbAddNewUser.Visible;

  bbEditIdentity.Visible:= Admin;
  bbEditIdentity.Enabled:= bbEditIdentity.Visible;

  bbArchive.Visible:= EntityEnabled and dmData.ArchivingIsNeeded;
  bbArchive.Enabled:= bbArchive.Visible;

  bbAddEntry.Visible:= EntityEnabled;
  bbAddEntry.Enabled:= bbAddEntry.Visible;

  fmAccountsTree.PopupMenu1.AutoPopup:= EntityEnabled;

  bbUsersManage.Visible:= Admin;
  bbUsersManage.Enabled:= bbUsersManage.Visible;

  bbReportsManage.Visible:= Admin;
  bbReportsManage.Enabled:= bbReportsManage.Visible;

  bbEditBanks.Visible:= Admin;
  bbEditBanks.Enabled:= bbEditBanks.Visible;

  bbBackup.Visible:= Admin;
  bbBackup.Enabled:= bbEditBanks.Visible;

  bbAddOrigCheque.Enabled:= EntityEnabled;
  bbPayCheque.Enabled:= EntityEnabled;
  bbWithdrawCheque.Enabled:= EntityEnabled;
  bbDelayCheque.Enabled:= EntityEnabled;
  bbChequeRD.Enabled:= EntityEnabled;

  dmdata.FillBanksBox(cbBanks.Items, BankIDs);

  if EntityEnabled then
    CreateEntryButtons;

  CreateReportButtons;

end;

initialization
  {$I main.lrs}

end.

