unit Pass;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons, DbCtrls, db, memds, IniFiles;

type

  { TfmPass }

  TfmPass = class(TForm)
    bbLogin: TBitBtn;
    bbBrowse: TBitBtn;
    bbRestore: TBitBtn;
    BitBtn2: TBitBtn;
    cbEntity: TComboBox;
    edUser: TEdit;
    edPassword: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    MemDataset1: TMemDataset;
    procedure bbBrowseClick(Sender: TObject);
    procedure bbLoginClick(Sender: TObject);
    procedure bbRestoreClick(Sender: TObject);
    procedure cbEntityChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    procedure FillCombo(Index: Integer);
    { public declarations }
  end; 

var
  fmPass: TfmPass;

implementation

uses Data, EditEntities, RestoreDatabase;

{ TfmPass }

procedure TfmPass.bbLoginClick(Sender: TObject);
var
  Ini: TIniFile;
begin
  try
    if cbEntity.ItemIndex = -1 then
      MessageDlg('لابد من إختيار وحدة محاسبية', mtInformation, [mbOK], 0)
    else
    with dmData do
    begin
      IBConnection1.DatabaseName:= MemDataset1.FieldByName('Database').AsString;
      IBConnection1.UserName:= edUser.Text;
      IBConnection1.Password:= edPassword.Text;
      IBConnection1.Open;
      sqGeneral.SQL.Text:= 'select * from users where Lower(Login) = :Login';
      sqGeneral.Params.ParamByName('Login').AsString:= LowerCase(edUser.Text);
      sqGeneral.Open;
      if sqGeneral.RecordCount = 0 then
        ShowMessage('لاتوجد صلاحية دخول لهذا المستخدم')
      else
      begin
        Ini:= TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
        Ini.WriteInteger('Settings', 'EntityIndex', cbEntity.ItemIndex);
        Ini.WriteString('Settings', 'User', edUser.Text);
        Ini.Free;
       // IBConnection1.Close;
        IBConnection1.Role:= sqGeneral.FieldByName('Role').AsString;
        MemDataset1.Close;
        ModalResult:= mrOk;
      end;
      sqGeneral.Close;
      IBConnection1.Close;
    end;

  except
  on e: exception do
  begin
    MessageDlg('تعذر الدخول: ' + e.Message, mtError, [mbOk], 0);
  end;

  end;
end;

procedure TfmPass.bbRestoreClick(Sender: TObject);
begin
  fmRestoreDatabase.ShowModal;
end;

procedure TfmPass.cbEntityChange(Sender: TObject);
begin
  MemDataset1.RecNo:= cbEntity.ItemIndex + 1;
end;

procedure TfmPass.FormActivate(Sender: TObject);
begin
  if edUser.Text = '' then
    edUser.SetFocus
  else
    edPassword.SetFocus;
end;

procedure TfmPass.FormCreate(Sender: TObject);
var
  AFileName: string;
  Ini: TIniFile;
  Index: Integer;
begin
  AFileName:= ChangeFileExt(ParamStr(0), '.ent');
  if FileExists(AFileName) then
    MemDataset1.LoadFromFile(AFileName);
  MemDataset1.Open;
  Ini:= TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
  Index:= Ini.ReadInteger('Settings', 'EntityIndex', -1);
  edUser.Text:= Ini.ReadString('Settings', 'User', '');
  FillCombo(Index);
  Ini.Free;
  if MemDataset1.RecordCount = 0 then
    bbBrowseClick(nil);
end;

procedure TfmPass.FillCombo(Index: Integer);
begin
  cbEntity.Clear;
  MemDataset1.First;
  while not MemDataset1.EOF do
  begin;
    cbEntity.Items.Add(MemDataset1.FieldByName('EntityName').AsString);
    MemDataset1.Next;
  end;
  MemDataset1.RecNo:= Index + 1;
  cbEntity.ItemIndex:= Index;
end;

procedure TfmPass.bbBrowseClick(Sender: TObject);
begin
  fmEditEntities.Init;
  fmEditEntities.ShowModal;
  MemDataset1.Close;
  MemDataset1.LoadFromFile(ChangeFileExt(ParamStr(0), '.ent'));
  MemDataset1.Open;
  FillCombo(0);
end;

initialization
  {$I pass.lrs}

end.

