unit RestoreDatabase;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons;

type

  { TfmRestoreDatabase }

  TfmRestoreDatabase = class(TForm)
    bbRestore: TBitBtn;
    BitBtn1: TBitBtn;
    edBackup: TEdit;
    edDatabase: TEdit;
    edHost: TEdit;
    edPassword: TEdit;
    edUser: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Memo1: TMemo;
    procedure bbRestoreClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  fmRestoreDatabase: TfmRestoreDatabase;

implementation

{ TfmRestoreDatabase }

uses UnitFirebirdServices;

procedure TfmRestoreDatabase.bbRestoreClick(Sender: TObject);
var
  FireBirdServices: TFirebirdServices;
  Res: Ansistring;
begin
  FireBirdServices:= nil;
  try


    FireBirdServices:= TFirebirdServices.Create;
    FireBirdServices.VerboseOutput:= True;
    with FireBirdServices do
    begin
      HostName:= edHost.Text;
      DBName:= edDatabase.Text;
      UserName := edUser.Text;
      Password := edPassword.Text;
      BkpName := edBackup.Text;

      Memo1.Font.Color:= clBlack;
      Memo1.Clear;

      try
        AttachService;

        StartRestore;

        while ServiceQuery(Res) do
          Memo1.Lines.Add(Res);

        if Memo1.Lines.Count > 5 then
          ShowMessage('تم إسترجاع قاعدة البيانات')
        else
          MessageDlg('لم يتم إسترجاع قاعدة البيانات', mtError, [mbOk], 0);

      finally
        DetachService;
      end;
      FireBirdServices.Free;
    end;

  except
    on e: exception do
    begin
      Memo1.Lines.Add(e.Message);
      Memo1.Font.Color:= clRed;
      if Assigned(FireBirdServices) then
        FireBirdServices.Free;
    end;
  end;

end;

initialization
  {$I restoredatabase.lrs}

end.

