unit SelDate;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons, ExtDlgs, EditBtn;

type

  { TfmSelDate }

  TfmSelDate = class(TForm)
    bbBrowse: TBitBtn;
    bbSelect: TBitBtn;
    bbCancel: TBitBtn;
    cbAccount: TComboBox;
    cbType: TComboBox;
    cxIncludeDetails: TCheckBox;
    cxDate: TCheckBox;
    cxIncludeArchived: TCheckBox;
    deFromDate: TDateEdit;
    deToDate: TDateEdit;
    edSearch: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    SaveDialog1: TSaveDialog;
    procedure bbBrowseClick(Sender: TObject);
    procedure bbSelectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    AccountIDs: array of Integer;
    { public declarations }
  end; 

var
  fmSelDate: TfmSelDate;

implementation

{ TfmSelDate }

uses AccountsTree;

procedure TfmSelDate.FormCreate(Sender: TObject);
begin
  deFromDate.Date:= Date;
  deToDate.Date:= Date;
end;

procedure TfmSelDate.bbSelectClick(Sender: TObject);
begin
  if (cbType.ItemIndex = 0) or (SaveDialog1.Execute) then
    ModalResult:= mrOK
end;

procedure TfmSelDate.bbBrowseClick(Sender: TObject);
var
  i: Integer;
begin
  fmAccountsTree.Init;
  if fmAccountsTree.ShowModal = mrOK then
  begin
    for i:= 0 to High(AccountIDs) do
      if fmAccountsTree.SelectedAccountID = AccountIDs[i] then
      begin
        cbAccount.ItemIndex:= i + 1;
        Break;
      end;
  end;
end;


initialization
  {$I seldate.lrs}

end.

