unit Users;

{$mode objfpc}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, DbCtrls, DBGrids, Buttons, db;

type

  { TfmUsers }

  TfmUsers = class(TForm)
    bbUpdateFullName: TBitBtn;
    bbUpdateRole: TBitBtn;
    bbUpdateRole1: TBitBtn;
    BitBtn1: TBitBtn;
    cbRole: TComboBox;
    Datasource1: TDatasource;
    DBNavigator1: TDBNavigator;
    deFullName: TDBEdit;
    DBGrid1: TDBGrid;
    dtUserID: TDBText;
    dtLogin: TDBText;
    DBText3: TDBText;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    rbDatabase: TRadioButton;
    rbServer: TRadioButton;
    procedure bbUpdateFullNameClick(Sender: TObject);
    procedure bbUpdateRole1Click(Sender: TObject);
    procedure bbUpdateRoleClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure Label6Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure Init;
  end; 

var
  fmUsers: TfmUsers;

implementation

{ TfmUsers }

uses Data, ChangePass;

procedure TfmUsers.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  dmData.sqUsers.Close;
end;

procedure TfmUsers.Label6Click(Sender: TObject);
var
  Users: string;
begin
  Users:= dmData.GetOtherDatabaseUsers;
  if Users <> '' then
    ShowMessage(Users)
  else
    ShowMessage('لايوجد');
end;

procedure TfmUsers.bbUpdateFullNameClick(Sender: TObject);
var
  User: string;
  Res: Ansistring;
begin
  User:= dtLogin.Field.AsString;
  if not dmData.UpdateUsername(dtUserID.Field.AsInteger, deFullName.Text, Res) then
     ShowMessage(Res);
  Init;
  dmData.sqUsers.Locate('Login', User, [loCaseInsensitive]);
end;

procedure TfmUsers.bbUpdateRole1Click(Sender: TObject);
var
  Res: Ansistring;
begin
  if MessageDlg('هل أنت متأكد من حذف المستخدم ' + dtLogin.Field.AsString, mtWarning, [mbYes, mbNo], 0) = mrYes then
  begin
    if not dmData.RemoveUser(dtLogin.Field.AsString, rbServer.Checked, Res) then
      ShowMessage(Res);
    Init;
  end;
end;

procedure TfmUsers.bbUpdateRoleClick(Sender: TObject);
var
  User: string;
  Res: Ansistring;
begin
  User:= dtLogin.Field.AsString;
  if not dmData.GrantRoleToUser(User, cbRole.Text, Res) then
     ShowMessage(Res);
  Init;
  dmData.sqUsers.Locate('Login', User, [loCaseInsensitive])
end;

procedure TfmUsers.BitBtn1Click(Sender: TObject);
var
  RecNo: Integer;
begin
  RecNo:= dmData.sqUsers.RecNo;
  fmChangePass.Init(dtLogin.Field.AsString, False);
  fmChangePass.ShowModal;
  Init;
  dmData.sqUsers.RecNo:= RecNo;
end;

procedure TfmUsers.Init;
begin
  dmData.sqUsers.Close;
  dmData.sqUsers.Open;
end;

initialization
  {$I users.lrs}

end.

